theory Intro_140519 
imports Main
(*"~~/src/HOL/Library/Polynomial"
  "~/repos/poly-WORK/Test"*)
begin

text {*
############ src/HOL$ grep -r "ector space" *
Hahn_Banach/Vector_Space.thy:header {* Vector spaces * }
Multivariate_Analysis/Finite_Cartesian_Product.thy:subsection {* Real vector space * }
Real_Vector_Spaces.thy:header {* Vector Spaces and Algebras over the Reals * }

############ src/HOL$ grep -r " basis " *
Multivariate_Analysis/Linear_Algebra.thy: !collinear /intervals
Multivariate_Analysis/Convex_Euclidean_Space.thy:subsection{ * Some Properties of subset of standard basis * }
*}

(*-------------------------------------------------------------------------------------------*)

(*EXERCISES 19.Mai
# no_trailing_zeros_raw_poly_rec
# equal_poly_rec_code
*)


term "\<exists> x. x \<in> UNIV"
term "? x. x : UNIV"
term "! x. x \<in> UNIV"

subsection {* lift_definition without instantiation *}

typedef ('a, 'b) poly_mapping =
  "{f :: 'a \<Rightarrow> 'b::zero. finite {x. f x \<noteq> 0}}"
  morphisms lookup Abs_poly_mapping
proof -
  have "(\<lambda>_::'a. (0 :: 'b)) \<in> ?poly_mapping" by simp
  then show ?thesis by (blast intro!: exI) 
qed

setup_lifting (no_code) type_definition_poly_mapping

typedef 'a mpoly = 
  "UNIV :: ((nat, nat) poly_mapping, 'a::zero) poly_mapping set"
 ..

(* type constraints from instantiation:  vvvvvv,   vvvvvv
for 2 args of polymapping respectively                   *)
lift_definition zero_poly_mapping :: "('a::type, 'b::zero) poly_mapping"
  is "\<lambda>k. 0"
  by simp

(* type constraints from instantiation:  vvvvvv,   vvvvvvvvvvvv*)
lift_definition plus_poly_mapping :: "('a::type, 'b::monoid_add) poly_mapping \<Rightarrow> ('a, 'b) poly_mapping \<Rightarrow> ('a, 'b) poly_mapping"
  is "\<lambda>f1 f2 k. f1 k + f2 k"
proof -
  fix f1 f2 :: "'a \<Rightarrow> 'b"
  assume "finite {k. f1 k \<noteq> 0}"
    and "finite {k. f2 k \<noteq> 0}"
  then have "finite ({k. f1 k \<noteq> 0} \<union> {k. f2 k \<noteq> 0})" by auto
  moreover have "{x. f1 x + f2 x \<noteq> 0} \<subseteq> {k. f1 k \<noteq> 0} \<union> {k. f2 k \<noteq> 0}"
    by auto
  ultimately show "finite {x. f1 x + f2 x \<noteq> 0}" by (blast intro: finite_subset)
qed


(*
lift_definition zero_mpoly :: "'a::zero mpoly"
  is "0 :: ((nat, nat) poly_mapping, 'a) poly_mapping" .

lift_definition plus_mpoly :: "'a mpoly \<Rightarrow> 'a mpoly \<Rightarrow> 'a mpoly"
  is "Groups.plus :: ((nat, nat) poly_mapping, 'a) poly_mapping \<Rightarrow> _" .

ERROR: Type unification failed: No type arity poly_mapping :: plus*)

(*term "(p::'a::zero mpoly) = 0"   ..fehlt*)

(*-------------------------------- protokoll 19.5.14-------------------------------------------*)
ML {*
(*--------------------- intro-to-sml p.28 *)
val fs = [1,2,3];
fold (curry op +) fs 0
*} ML {*
*} ML {*
*} ML {*
[1,2,3,4,5] @ [6,7,8,9]
*} ML {*
*} ML {*
*} ML {*
infix dvd
fun n dvd t = n mod t = 0

fun divisors n = 
  let fun divs t ts n =
    if t > n then ts
    else if n dvd t then divs t (ts @ [t]) (n div t) else divs (t + 1) ts n
  in divs 2 [1] n end

fun is_perfect n =
  let val fs = divisors n
  in fold (curry op +) fs 0 = n end

fun write_perfect n = if is_perfect n then writeln (string_of_int n ^ " is perfect") else ()
fun increment i n f = if i > n then () else (f i; increment (i+1) n f)
;
increment 1 9999 write_perfect
*} ML {*
fun divisors n = 
  let fun divs t ts n =
(writeln ("divs: " ^ string_of_int t ^ ", ["                (*...ad-hoc zum debuggen*)
^ commas (map string_of_int ts) ^ "], " ^ string_of_int n); (*...ad-hoc zum debuggen*)
    if t > n then ts
    else if n dvd t then divs t (ts @ [t]) (n div t) else divs (t + 1) ts n
)                                                           (*...ad-hoc zum debuggen*)
  in divs 2 [1] n end
*} ML {*
map string_of_int [1,2,3];
commas (map string_of_int [1,2,3]);
commas (map string_of_int [1,2,3]);
*} ML {*
(*  *)
*} ML {*
val fs = divisors 6;
val fs = divisors 28;
*} ML {*
*} ML {*
*} ML {*
is_perfect 6;

*} ML {*
*} ML {*

*} ML {*
*} ML {*
*} text {*
inc 1 9999 write_perfect
*} ML {*
*} ML {*

*} ML {*
*} ML {*
*} ML {*
*} ML {*
*}


end
