theory Intro_140623 imports Main begin


datatype 'a raw_poly_rec = Coeff 'a | Powers "('a raw_poly_rec) list"

value "Coeff"  --{*:: "'a \<Rightarrow> 'a raw_poly_rec"*}
value "Coeff (3::int)"  --{*:: "int raw_poly_rec"*}
value "Powers" --{*:: "'a raw_poly_rec list \<Rightarrow> 'a raw_poly_rec"*}
value "Powers [Coeff (1::int), Coeff 2]" --{*:: "'a raw_poly_rec list \<Rightarrow> 'a raw_poly_rec"*}
value "Powers [Coeff (1::int), Powers [Coeff 0, Coeff 2], Powers [Coeff 0, Coeff 0, Coeff 3]]"
  --{*1 + 2.x.y + 3.x^2.y^2 =
      x^0.1 + x^1.(y^0.0 + y^1.2) + x^2.(y^0.0 + y^1.0 + y^2.3)*}
 
fun smult :: "'a  \<Rightarrow> ('a::{times}) raw_poly_rec \<Rightarrow> 'a raw_poly_rec" 
where
  "smult s (Coeff c) = Coeff (s * c)"
| "smult s (Powers ps) = Powers (map (smult s) ps)"

fun smult_int :: "int  \<Rightarrow> int raw_poly_rec \<Rightarrow> int raw_poly_rec" 
where
  "smult_int s (Coeff c) = Coeff (s * c)"
| "smult_int s (Powers ps) = Powers (map (smult_int s) ps)"

value "map"      --{*:: "('a              \<Rightarrow> 'b)             \<Rightarrow> 'a list \<Rightarrow> 'b list"*}
value "smult xxx" --{*:: "'a raw_poly_rec \<Rightarrow> 'a raw_poly_rec"                     *}
value "map (smul xxx)" --{*::                                  "'a list \<Rightarrow> 'b list"*}
value "map (smul xxx) yyy" --{*::                                          'b list"*}

value "let s = (4::int);
    p = Powers [Coeff (1::int), Powers [Coeff 0, Coeff 2], Powers [Coeff 0, Coeff 0, Coeff 3]]
  in smult s p" --{**}

definition s :: int where "s = 4"
definition pppp :: "int raw_poly_rec" where 
  "pppp = Powers [Coeff (1::int), Powers [Coeff 0, Coeff 2], Powers [Coeff 0, Coeff 0, Coeff 3]]"

value "smult s pppp" 
  --{*"Powers [Coeff 4, Powers [Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 0, Coeff 12]]"*}

value "smult" --{**}

(* ACHTUNG: haben wir alle Sonderf"alle von raw_poly_rec erfasst ?????????????????????????? *)

value "(Powers [])" --{*:: "'a raw_poly_rec"*}
value "let p = Powers []
  in smult 4 p" --{**}
value "(Powers [Powers [Powers [Powers []]]])" --{*:: "'a raw_poly_rec"*}
value "let p = Powers [Powers [Powers [Powers []]]]
  in smult 4 p" --{**}
value "(Powers [Coeff (0::int)])" --{*:: "'a raw_poly_rec"*}
value "(Powers [Coeff (0::int), Coeff 0, Coeff 0, Coeff 0, Coeff 0])" --{*:: "'a raw_poly_rec"*}
value "let p = Powers [Coeff (0::int), Coeff 0, Coeff 0, Coeff 0, Coeff 0]
  in smult 4 p" --{**}
  
(* wir haben unendlich viele 0-Polynome *)
value "Powers [] = Coeff 0" --{*"False" :: "bool"*}
value "Powers [] = Powers []" --{*"False" :: "bool"*}
value "xx" --{**}
value "xx" --{**}
value "xx" --{**}

export_code smult in SML
ML {*
structure List : sig
  val map : ('a -> 'b) -> 'a list -> 'b list
end = struct

fun map f [] = []
  | map f (x :: xs) = f x :: map f xs;

end; (*struct List*)

structure Arith : sig
  type 'a zero
  val zero : 'a zero -> 'a
  type 'a times
  val times : 'a times -> 'a -> 'a -> 'a
end = struct

type 'a zero = {zero : 'a};
val zero = #zero : 'a zero -> 'a;

type 'a times = {times : 'a -> 'a -> 'a};
val times = #times : 'a times -> 'a -> 'a -> 'a;

end; (*struct Arith*)

structure Intro_140623 : sig
  datatype 'a raw_poly_rec = Coeff of 'a | Powers of 'a raw_poly_rec list
  val smult :
    'a Arith.times * 'a Arith.zero -> 'a -> 'a raw_poly_rec -> 'a raw_poly_rec
end = struct

datatype 'a raw_poly_rec = Coeff of 'a | Powers of 'a raw_poly_rec list;

fun smult (A1_, A2_) s (Coeff c) = Coeff (Arith.times A1_ s c)
  | smult (A1_, A2_) s (Powers ps) = Powers (List.map (smult (A1_, A2_) s) ps);

end; (*struct Intro_140623*)
*}

ML {* Intro_140623.smult *}

export_code smult_int in SML


end
