theory TestMiniParser imports Main begin

section {* fun aux *}
ML {*
*} ML {* (* cp from isac.gui.mawen.syntax.XSyntax *)
fun prior "=" = 50
  | prior "+" = 65
  | prior "-" = 65
(*  | prior "-" = 80   "Groups.plus_class.uminus" *)
  | prior "*" = 70
  | prior "/" = 70
  | prior "^" = 80
  | prior str = error ("prior: called with" ^ str)
*} ML {* (* Scala format *)
fun string_of_ast (Ast.Constant str) = "Ast.Constant" ^ enclose "(" ")" (quote str)
  | string_of_ast (Ast.Variable str) = "Ast.Variable" ^ enclose "(" ")" (quote str)
  | string_of_ast (Ast.Appl asts) = "Ast.Appl" ^ enclose "(List(" "))" (commas (map string_of_ast asts))
*} ML {* (* SML format *)
fun string_of_ast (Ast.Constant str) = "Ast.Constant " ^ quote str
  | string_of_ast (Ast.Variable str) = "Ast.Variable " ^ quote str
  | string_of_ast (Ast.Appl asts) = "Ast.Appl " ^ enclose "[" "]" (commas (map string_of_ast asts))
fun string_of_asts asts = asts |> map string_of_ast |> commas |> enclose "[" "]" 
*} ML {*
fun indent 1 = "  "
  | indent n = "  " ^ indent (n - 1)
fun indent 1 = "#"
  | indent n = "#" ^ indent (n - 1)
; indent 3 = "###"
*} ML {*
*}
section {* fun tokenize source *}
ML {*
*} ML {*
datatype token = IDENT of string | INT of string
  | DELIM of string | BINOP of string | LPAR of string | RPAR of string (*all 1 char for tokenize*)
  | S (*start*) | T (*terminal*) | N (*NONterminal*) | PRIOR of int (*priority*) (*all for shift-reduce parsing*) 
  | ERROR of string
fun string_of_token (IDENT s) = "IDENT " ^ s
  | string_of_token (INT s) =   "INT " ^ s
  | string_of_token (DELIM s) = "DELIM " ^ s
  | string_of_token (BINOP s) = "BINOP " ^ s
  | string_of_token (LPAR s) =  "LPAR " ^ s
  | string_of_token (RPAR s) =  "RPAR " ^ s
  | string_of_token S        = "S"
  | string_of_token T        = "T"
  | string_of_token N        = "N"
  | string_of_token (PRIOR i) = "PRIOR " ^ string_of_int i
  | string_of_token (ERROR s) = "ERROR " ^ s
fun string_of_tokens toks = toks |> map string_of_token |> commas |> enclose "[" "]" 
*} ML {* (* cp from isac.gui.mawen.syntax.XSyntax *)
fun prior' (BINOP "=") = 50
  | prior' (BINOP "+") = 65
  | prior' (BINOP "-") = 65
(*  | prior "-" = 80   "Groups.plus_class.uminus" *)
  | prior' (BINOP "*") = 70
  | prior' (BINOP "/") = 70
  | prior' (BINOP "^") = 80
  | prior' _ = 0 (* convenient for shift-reduce-parsing *)
(*  | prior str = error ("prior: called with" ^ str)*)
*} ML {*
fun is_letter str = ord(str) >= ord("a") andalso ord(str) <= ord("z")
  orelse ord(str) >= ord("A") andalso ord(str) <= ord("Z")
  orelse str = "_"
fun is_digit str = ord(str) >= ord("0") andalso ord(str) <= ord("9")
fun is_alphanum str = is_letter str orelse is_digit str

(* tokenize: takes only 1 char as delimiters *)
val delim = [" ", ","]
val binop = ["-" (* can also be unary *), "+", "*", "/", "^", "="]
fun is_binop str = member op = binop str
val lpar = ["(", "["]
fun is_lpar str = member op = lpar str
val rpar = [")", "]"]
fun is_rpar str = member op = rpar str
val par = lpar @ rpar
fun is_delim str = member op = delim str orelse is_binop str orelse member op = par str

exception Token_Err of token list * string list
exception Parse_Err of Ast.ast list * token list
*} ML {*
fun spec_delim (DELIM str) =
    if is_binop str then BINOP str else
    if is_lpar str then LPAR str else
    if is_rpar str then RPAR str else DELIM str
  | spec_delim tok = tok
fun specify_delims toks = map spec_delim toks
*} ML {*
(* generates tokens in reverse order until FINAL rev toks*)
fun lexe (toks, s :: source) =
      ((*writeln ("lexe: " ^ string_of_tokens toks ^ ", " ^ implode (s :: source) ^ ")");*)
      if is_letter s then ident (IDENT s :: toks, source) else
      if is_digit s then integer (INT s :: toks, source) else
      if is_delim s then delim (DELIM s :: toks, source) else lexe (toks, s :: source)
      )
    | lexe (toks, []) = rev toks
  and ident (IDENT i :: toks, s :: source) =
      ((*writeln ("ident:   IDENT " ^ i ^ ", " ^ implode (s :: source) ^ ")");*)
      if is_alphanum s then ident (IDENT (i ^ s) :: toks, source) else lexe (IDENT i :: toks, s :: source)
      )
    | ident (toks, []) = rev toks
    | ident _ = raise Token_Err ([], ["tokenize ident: this cannot happen"])
  and integer (INT i :: toks, s :: source) =
      ((*writeln ("integer: INT " ^ i ^ ", " ^ implode (s :: source) ^ ")");*)
      if is_digit s then integer (INT (i ^ s) :: toks, source) else lexe (INT i :: toks, s :: source)
      )
    | integer (toks, []) = rev toks
    | integer _ = raise Token_Err ([], ["tokenize integer: this cannot happen"])
  and delim (DELIM s :: toks, source) =
      let val tok = DELIM s
      in if s = " " then lexe (toks, source) else lexe (tok :: toks, source) end
    | delim _ = raise Token_Err ([], ["delim tokenize: this cannot happen"])
fun tokenize source = lexe ([], source) |> specify_delims
*} ML {*
*} 
section {* test tokenize DONE, TODO parse *}
subsection {* UCs and data for code building *}
ML {*
*} ML {*(*UC 3.5*)
val input = Symbol.explode "Simplify (1 + 1 / 2 + (2 / (x + 3) + 2 / (x - 3)) / (8 * x / (x ^ 2 - 9)))";
val toks = tokenize input
*} ML {*(*UC 3.7*)
val input = Symbol.explode "Diff (x ^ 2 + sin (3 * x ^ 4), x)";
val toks = tokenize input;
if toks = [IDENT "Diff", LPAR "(", IDENT "x", BINOP "^", INT "2", BINOP "+", IDENT "sin", 
  LPAR "(", INT "3", BINOP "*", IDENT "x", BINOP "^", INT "4", RPAR ")", DELIM ",", IDENT "x", RPAR ")"]
  then () else error "tokenize x + 1 + -1 * 2 = 0";
*} ML {*(*UC 3.8*)
val input = Symbol.explode "y x = Integral c_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^ 2 + -1 * q_0 / 6 * x ^ 3) D x";
val toks = tokenize input
*} ML {*
val input = Symbol.explode "Problem (Biegelinie, [setzeRandbedingungen, Biegelinien])";
val toks = tokenize input;
if toks = [IDENT "Problem", LPAR "(", IDENT "Biegelinie", DELIM ",", LPAR "[", 
  IDENT "setzeRandbedingungen", DELIM ",", IDENT "Biegelinien", RPAR "]", RPAR ")"]
  then () else error "tokenize x + 1 + -1 * 2 = 0";
*} ML {*
val input = Symbol.explode "[L * q_0 = c, 0 = (2 * c_2 + 2 * L * c + -1 * L ^ 2 * q_0) / 2, 0 = c_4, 0 = c_3]";
val toks = tokenize input
*} ML {*(*UC minisubpbl*)
val input = Symbol.explode "x + 1 + -1 * 2 = 0";
val toks = tokenize input;
if toks = 
[IDENT "x", BINOP "+", INT "1", BINOP "+", BINOP "-", INT "1", BINOP "*", INT "2", BINOP "=", INT "0"]
  then () else error "tokenize x + 1 + -1 * 2 = 0";
*} ML {*(* TODO test parentheses *)
*} ML {*
*} ML {*(* test priority *)
val input = Symbol.explode "a + b * c ^ d";
val toks = tokenize input;
if toks = [IDENT "a", BINOP "+", IDENT "b", BINOP "*", IDENT "c", BINOP "^", IDENT "d"]
  then () else error "tokenize a + b * c ^ d";
*}
  
section {* TODO NEW fun pars_binop again with ***ast list*** instead 'ast stack'  *}
ML {* (* code is nicer with 'list' than with 'stack' *)
*} ML {*
*} 

section {* trials with Stack *}
ML {*
*} ML {*
*} text {* trying ~~/src//Pure/General/stack.ML: too specific

Ast.Constant "xxx" : Ast.ast

val stack = Stack.init (Ast.Constant "init");
Stack.dest stack;

val stack = Stack.push stack;
*} ML {*
datatype 'a stack = Stack of 'a list
fun top (Stack (e :: _)) = e
  | top (Stack []) = raise List.Empty
fun pop (Stack (_ :: es)) = (Stack (es))
  | pop (Stack []) = raise List.Empty
fun push (Stack es) e = (Stack (e :: es))
*} ML {* 
pop;  (* = fn: 'a stack -> 'a stack *)
top;  (* = fn: 'a stack -> 'a *)
push; (* = fn: 'a stack -> 'a -> 'a stack *)
*} ML {* 
val stack = Stack [] : Ast.ast stack
(*val stack = push stack (Ast.Constant "dummy")*)
*} ML {*
*}

(* ONLY handles algebraic terms, does NOT handle: pairs, lists, etc
  see https://en.wikipedia.org/wiki/Simple_precedence_parser      *)
section {* OLD fun parse (asts, ... WITH Stack *}
ML {*
fun tok_to_ast (IDENT str) = Ast.Variable str
  | tok_to_ast (INT str) = Ast.Variable str
  | tok_to_ast (BINOP str) = Ast.Constant str
  | tok_to_ast tok = raise error ("tok_to_ast: NOT impl. " ^ string_of_token tok)
*} ML {*
*} ML {*
(* = fn: Ast.ast stack * token list -> Ast.ast stack * token list *)
fun shift1 (stack, tok :: toks) = (push stack (tok_to_ast tok), toks)
  | shift1 _ = raise List.Empty
(* = fn: Ast.ast stack * token list -> Ast.ast stack * token list *)
fun shift2 (stack, arg1 :: binop (*:: arg2*) :: tks) =
    let
      val stack = push stack (tok_to_ast arg1)
      val stack = push stack (tok_to_ast binop)
(*    val stack = push stack (tok_to_ast arg2) *)
    in (stack, tks) end
  | shift2 (_, toks) = error ("shift2: " ^ string_of_tokens toks)
*} ML {*






(* for pars_binop *)
fun pivot (Stack (Ast.Constant str :: _)) = prior str
  | pivot (Stack [Ast.Appl _]) = 0 (* recognises 'reduce' finished *)
  | pivot (Stack (_)) = 0 (* recognises init.pars_binop for shift *)
(* for reduce *)
fun pivot' (Stack (_ :: Ast.Constant str :: _)) = prior str
  | pivot' (Stack [Ast.Appl _]) = 0 (* recognises 'reduce' finished *)
  | pivot' (Stack (_)) = 0 (* recognises init.pars_binop for shift *)










*} ML {*
fun string_of_stack (Stack asts) = "Stack" ^ string_of_asts asts
*} ML {*
*} ML {*
*} ML {*







fun reduc (Stack (arg1 :: binop :: arg2 :: asts)) = Stack ((Ast.mk_appl binop [arg2, arg1]) :: asts)
  | reduc (stack as Stack [Ast.Appl _]) = stack
  | reduc stack = error ("reduc MATCH " ^ string_of_stack stack)
*} ML {*
(* pars_binop calls with (pivot asts) >= pri *)
fun reduce _ (Stack [ast]) = Stack [ast]
  | reduce pri asts =
    let val asts = reduc asts
    in if (pivot' asts) >= pri then reduce pri asts else asts end





*} ML {*
*} ML {*
*} ML {*
*} ML {*
*} ML {*
val stack0 = Stack [Ast.Variable "d", Ast.Constant "^", Ast.Variable "c", Ast.Constant "*", Ast.Variable "b", Ast.Constant "+", Ast.Variable "a"];
*} ML {*
stack;
val stack = reduc stack0 (*-------*);
if stack = Stack[Ast.Appl [Ast.Constant "^", Ast.Variable "c", Ast.Variable "d"], Ast.Constant "*", Ast.Variable "b", Ast.Constant "+", Ast.Variable "a"]
then () else error "reduc > ";
pivot stack;
writeln(string_of_stack stack);
writeln("-------------------");
*} ML {*
stack;
val stack = reduc stack (*---- GOON 1 ---*);
if stack = Stack[Ast.Appl [
  Ast.Constant "*",
  Ast.Variable "b",
  Ast.Appl [
    Ast.Constant "^",
    Ast.Variable "c",
    Ast.Variable "d"]],
  Ast.Constant "+", Ast.Variable "a"]
then () else error "reduc  =";
pivot stack;
writeln(string_of_stack stack);
writeln("-------------------");
*} ML {*
stack;
val stack = reduc stack (*-------*);
if stack = Stack[Ast.Appl [Ast.Constant "+", Ast.Variable "a", Ast.Appl [Ast.Constant "*", Ast.Variable "b", Ast.Appl [Ast.Constant "^", Ast.Variable "c", Ast.Variable "d"]]]] 
then () else error "reduc > ";
pivot stack;
writeln(string_of_stack stack);
writeln("-------------------");
*} ML {*
val stack0 = Stack [Ast.Variable "d", Ast.Constant "^", Ast.Variable "c", Ast.Constant "*", Ast.Variable "b", Ast.Constant "+", Ast.Variable "a"];
val pri = prior "*"
val stack = reduce pri stack0 (*-------*);
if stack = Stack[Ast.Appl [Ast.Constant "*", Ast.Variable "b", Ast.Appl [Ast.Constant "^", Ast.Variable "c", Ast.Variable "d"]], Ast.Constant "+", Ast.Variable "a"] 
then () else error "reduce '";
pivot stack;
writeln(string_of_stack stack);
writeln("-------------------");
*} ML {*
val input = Symbol.explode "a + b * c ^ d          ^ e";
val asts = Stack [Ast.Variable "e", Ast.Constant "^", Ast.Variable "d", Ast.Constant "^", Ast.Variable "c", Ast.Constant "*", Ast.Variable "b", Ast.Constant "+", Ast.Variable "a"];
*} ML {*
if reduce (prior "^") asts
= Stack[Ast.Appl [Ast.Constant "^", Ast.Variable "c", Ast.Appl [Ast.Constant "^", Ast.Variable "d", Ast.Variable "e"]], Ast.Constant "*", Ast.Variable "b", Ast.Constant "+", Ast.Variable "a"] 
then () else error "reduce (prior '') ''";
*} ML {*
writeln(string_of_stack stack);
writeln("-------------------");
*} text {*
(*GOON 2*) reduce 0 stack ?????????????????????????????
*} ML {*
*} ML {*
*} ML {* (* cp from isac.gui.mawen.syntax.XSyntax *)
fun prior'' (Ast.Constant "=") = 50
  | prior'' (Ast.Constant "+") = 65
  | prior'' (Ast.Constant "-") = 65
(*  | prior'' "-" = 80   "Groups.plus_class.uminus" *)
  | prior'' (Ast.Constant "*") = 70
  | prior'' (Ast.Constant "/") = 70
  | prior'' (Ast.Constant "^") = 80
  | prior'' (Ast.Variable _) = 99 (* convenient for shift-reduce-parsing *)
  | prior'' ast = error ("prior'': called with " ^ string_of_ast ast)
*} ML {*
fun dest (Stack asts) = (asts : Ast.ast list)
*} ML {*
  (* start of parsing        vvv *)
fun pars_binop (asts as Stack [], toks as (_(*arg*) :: (BINOP _) :: _)) =
    pars_binop (shift2 (asts, toks))
  (* end of parsing, hopefully an IDENT or NUM          vvv*)
  | pars_binop ((*asts as*) (Stack (binop :: ass)), (*toks as*) (arg :: [])) =
    Ast.mk_appl binop [hd (dest (reduce 0 (Stack (ass)))), tok_to_ast arg] (*list BETTER stack*)
  (* look ahead to next infix operator      vvv *)
  | pars_binop (asts, toks as (arg :: (binop as (BINOP str)) :: tks)) =
    if pivot asts >= prior str
    then (* >= reduce (left associative) *)
      let
        val _ = writeln("1 pivot asts= " ^ string_of_int (pivot asts) ^ ">=" ^ string_of_int (prior str)  ^ " =pri' tok=" ^ string_of_token (BINOP str) ^ ", asts=" ^ string_of_stack asts ^ ", " ^ " tks=" ^ string_of_tokens toks)
        val asts = push asts (tok_to_ast arg)
        val asts = reduce (prior str) asts (* _all_ productions according on prior str *)
        val _ = writeln("2 pivot asts= " ^ string_of_int (pivot asts) ^ ">=" ^ string_of_int (prior str)  ^ " =pri' tok=" ^ string_of_token (BINOP str) ^ ", asts=" ^ string_of_stack asts ^ ", " ^ " tks=" ^ string_of_tokens toks)
      in pars_binop (push asts (tok_to_ast binop), tks) end                                                                            
    else (* <  shift *)                                                                                         
      let                                                                                                       
        val _ = writeln("3 pivot asts= " ^ string_of_int (pivot asts) ^ "< " ^ string_of_int (prior str)  ^ " =pri' tok=" ^ string_of_token (BINOP str) ^ ", asts=" ^ string_of_stack asts ^ ", " ^ " tks=" ^ string_of_tokens toks)
        val (asts, _(*toks*)) = shift2 (asts, toks)
(*        val _ = writeln("4 pivot asts= " ^ string_of_int (pivot asts) ^ "< " ^ string_of_int (prior str)  ^ " =pri' tok=" ^ string_of_token (BINOP str) ^ ", asts=" ^ string_of_stack asts ^ ", " ^ " tks=" ^ string_of_tokens toks)*)
      in pars_binop (asts, tks) end
  | pars_binop (asts, toks) = error ("pars_binop MATCH (" ^ string_of_stack asts ^ ", " ^ string_of_tokens toks ^ ")")
*} ML {*
*} 

section {* test pars_binop  TODO: shift before 'stack' *}
ML {*
*} ML {* (*OK ===================================== "a + b ^ c * d ^ e + f"*) 
val input = Symbol.explode "a + b ^ c * d ^ e + f";
val toks = tokenize input;
if pars_binop (Stack [], toks) =
Ast.Appl [
  Ast.Constant "+", 
  Ast.Appl [
    Ast.Constant "+", 
    Ast.Variable "a", 
    Ast.Appl [
      Ast.Constant "*", 
      Ast.Appl [Ast.Constant "^", Ast.Variable "b", Ast.Variable "c"], 
      Ast.Appl [Ast.Constant "^", Ast.Variable "d", Ast.Variable "e"]]], 
  Ast.Variable "f"] 
then () else error "pars_binop 'a + b ^ c * d ^ e + f'"
*} ML {* (*OK ===================================== "a + b * c ^ d = e"*) 
val input = Symbol.explode "a + b * c ^ d = e";
val toks = tokenize input;
if pars_binop (Stack [], toks) =
Ast.Appl [
  Ast.Constant "=", 
  Ast.Appl [
    Ast.Constant "+", 
    Ast.Variable "a", 
    Ast.Appl [
      Ast.Constant "*", 
      Ast.Variable "b", 
      Ast.Appl [Ast.Constant "^", Ast.Variable "c", Ast.Variable "d"]]], 
  Ast.Variable "e"] 
then () else error "pars_binop 'a + b * c ^ d = e'"
*} ML {* (*OK ===================================== "a + b + c + d"*) 
val input = Symbol.explode "a + b + c + d";
val toks = tokenize input;
if toks = [IDENT "a", BINOP "+", IDENT "b", BINOP "+", IDENT "c", BINOP "+", IDENT "d"]
  then () else error "tokenize a + b";
if pars_binop (Stack [], toks) =
  Ast.Appl[
    Ast.Constant("+"),
    Ast.Appl[
      Ast.Constant("+"),
      Ast.Appl[
        Ast.Constant("+"),
        Ast.Variable("a"),
        Ast.Variable("b")],
      Ast.Variable("c")],
    Ast.Variable("d")]
then () else error "pars a + b + c + d"
*} ML {*
*} ML {*
*} ML {* 
*} ML {*
*} ML {*
*} ML {* 
*} ML {*
val ast = pars_binop (Stack [], toks);
writeln(string_of_ast ast)
*} ML {* 
*}   

  
  
  
end