theory Try_Examples 
imports "~/repos/poly-WORK/Examples" 
  (*DELETE*)"~/repos/poly-WORK/Distributive"(*instead Examples imports...*)
  (*DELETE*)"~/repos/poly-WORK/Recursive"   (*instead Examples imports...*)
begin

subsection {* The abstract @{typ "'a mpoly"} *}
subsubsection {* Addition *}

subsubsection {* Multiplication*}

subsubsection {**}

subsection {* The distributive representation @{typ "'a poly_distr"} *}
subsubsection {* *}

subsubsection {* *}

subsubsection {**}

subsection {* The recursive representation @{typ "'a poly_rec"} *}
subsubsection {* Addition *}

subsubsection {* Multiplication *}
definition try_times :: "int mpoly \<Rightarrow> int mpoly \<Rightarrow> int mpoly"
where "try_times p q = p * q"
definition p2x3y :: "int mpoly" --{* recursive dense *}
where "p2x3y = monom' (REC (\<lambda>_. DENSE)) (Nat_Mapping.single' DENSE 1 1) 2 +
               monom' (REC (\<lambda>_. DENSE)) (Nat_Mapping.single' DENSE 0 1) 3"
value p2x3y --{*= "Rec (Powers (Dense [Powers (Dense [Coeff 0, Coeff 2]), Coeff 3]))"*}

definition p4x5y :: "int mpoly" --{* recursive dense *}
where "p4x5y = monom' (REC (\<lambda>_. DENSE)) (Nat_Mapping.single' DENSE 1 1) 4 +
               monom' (REC (\<lambda>_. DENSE)) (Nat_Mapping.single' DENSE 0 1) 5"
value p4x5y --{*= "Rec (Powers (Dense [Powers (Dense [Coeff 0, Coeff 2]), Coeff 3]))"*}
value "p2x3y * p4x5y" --{*= "Rec (
  Powers (Dense [Powers (Dense [Coeff 0, Coeff 8]), Powers (Dense [Coeff 10, Coeff 12]), Coeff 15]))"
NOT OK; OK WOULD BE = "Rec (
  Powers (Dense [Powers (Dense [Coeff 0, Coeff 0, Coeff 8]), Powers (Dense [Coeff 0, Coeff 22]), Coeff 15]))"
*}

subsubsection {* Mult. foldr gen.code*}
export_code try_times p2x3y p4x5y in SML module_name Try_Times 
ML {* (* from poly 381393f4c823 *)
(*
structure Try_Times : sig
  type num
  type int
  type nat
  type 'a nat_mapping
  type implb
  type 'a mpoly
  type impl
  val p2x3y : int mpoly
  val p4x5y : int mpoly
  val try_times : int mpoly -> int mpoly -> int mpoly
end = struct
*)
type 'a uminus = {uminus : 'a -> 'a};
val uminus = #uminus : 'a uminus -> 'a -> 'a;

fun uminus_funa B_ a x = uminus B_ (a x);

fun uminus_fun B_ = {uminus = uminus_funa B_} : ('a -> 'b) uminus;

datatype num = One | Bit0 of num | Bit1 of num;

fun equal_num (Bit0 numa) (Bit1 num) = false
  | equal_num (Bit1 numa) (Bit0 num) = false
  | equal_num One (Bit1 num) = false
  | equal_num (Bit1 num) One = false
  | equal_num One (Bit0 num) = false
  | equal_num (Bit0 num) One = false
  | equal_num (Bit1 numa) (Bit1 num) = equal_num numa num
  | equal_num (Bit0 numa) (Bit0 num) = equal_num numa num
  | equal_num One One = true;

datatype int = Zero_int | Pos of num | Neg of num;

fun equal_inta (Neg k) (Neg l) = equal_num k l
  | equal_inta (Neg k) (Pos l) = false
  | equal_inta (Neg k) Zero_int = false
  | equal_inta (Pos k) (Neg l) = false
  | equal_inta (Pos k) (Pos l) = equal_num k l
  | equal_inta (Pos k) Zero_int = false
  | equal_inta Zero_int (Neg l) = false
  | equal_inta Zero_int (Pos l) = false
  | equal_inta Zero_int Zero_int = true;

type 'a equal = {equal : 'a -> 'a -> bool};
val equal = #equal : 'a equal -> 'a -> 'a -> bool;

val equal_int = {equal = equal_inta} : int equal;

val one_inta : int = Pos One;

type 'a one = {one : 'a};
val one = #one : 'a one -> 'a;

val one_int = {one = one_inta} : int one;

fun uminus_inta (Neg m) = Pos m
  | uminus_inta (Pos m) = Neg m
  | uminus_inta Zero_int = Zero_int;

fun plus_num (Bit1 m) (Bit1 n) = Bit0 (plus_num (plus_num m n) One)
  | plus_num (Bit1 m) (Bit0 n) = Bit1 (plus_num m n)
  | plus_num (Bit1 m) One = Bit0 (plus_num m One)
  | plus_num (Bit0 m) (Bit1 n) = Bit1 (plus_num m n)
  | plus_num (Bit0 m) (Bit0 n) = Bit0 (plus_num m n)
  | plus_num (Bit0 m) One = Bit1 m
  | plus_num One (Bit1 n) = Bit0 (plus_num n One)
  | plus_num One (Bit0 n) = Bit1 n
  | plus_num One One = Bit0 One;

fun times_num (Bit1 m) (Bit1 n) =
  Bit1 (plus_num (plus_num m n) (Bit0 (times_num m n)))
  | times_num (Bit1 m) (Bit0 n) = Bit0 (times_num (Bit1 m) n)
  | times_num (Bit0 m) (Bit1 n) = Bit0 (times_num m (Bit1 n))
  | times_num (Bit0 m) (Bit0 n) = Bit0 (Bit0 (times_num m n))
  | times_num One n = n
  | times_num m One = m;

fun times_inta (Neg m) (Neg n) = Pos (times_num m n)
  | times_inta (Neg m) (Pos n) = Neg (times_num m n)
  | times_inta (Pos m) (Neg n) = Neg (times_num m n)
  | times_inta (Pos m) (Pos n) = Pos (times_num m n)
  | times_inta Zero_int l = Zero_int
  | times_inta k Zero_int = Zero_int;

fun bitM One = One
  | bitM (Bit0 n) = Bit1 (bitM n)
  | bitM (Bit1 n) = Bit1 (Bit0 n);

fun dup (Neg n) = Neg (Bit0 n)
  | dup (Pos n) = Pos (Bit0 n)
  | dup Zero_int = Zero_int;

fun minus_inta (Neg m) (Neg n) = sub n m
  | minus_inta (Neg m) (Pos n) = Neg (plus_num m n)
  | minus_inta (Pos m) (Neg n) = Pos (plus_num m n)
  | minus_inta (Pos m) (Pos n) = sub m n
  | minus_inta Zero_int l = uminus_inta l
  | minus_inta k Zero_int = k
and sub (Bit0 m) (Bit1 n) = minus_inta (dup (sub m n)) (Pos One)
  | sub (Bit1 m) (Bit0 n) = plus_inta (dup (sub m n)) (Pos One)
  | sub (Bit1 m) (Bit1 n) = dup (sub m n)
  | sub (Bit0 m) (Bit0 n) = dup (sub m n)
  | sub One (Bit1 n) = Neg (Bit0 n)
  | sub One (Bit0 n) = Neg (bitM n)
  | sub (Bit1 m) One = Pos (Bit0 m)
  | sub (Bit0 m) One = Pos (bitM m)
  | sub One One = Zero_int
and plus_inta (Neg m) (Neg n) = Neg (plus_num m n)
  | plus_inta (Neg m) (Pos n) = sub n m
  | plus_inta (Pos m) (Neg n) = sub m n
  | plus_inta (Pos m) (Pos n) = Pos (plus_num m n)
  | plus_inta Zero_int l = l
  | plus_inta k Zero_int = k;

type 'a times = {timesa : 'a -> 'a -> 'a};
val timesa = #timesa : 'a times -> 'a -> 'a -> 'a;

type 'a minus = {minus : 'a -> 'a -> 'a};
val minus = #minus : 'a minus -> 'a -> 'a -> 'a;

type 'a zero = {zero : 'a};
val zero = #zero : 'a zero -> 'a;

type 'a plus = {plus : 'a -> 'a -> 'a};
val plus = #plus : 'a plus -> 'a -> 'a -> 'a;

type 'a semigroup_add = {plus_semigroup_add : 'a plus};
val plus_semigroup_add = #plus_semigroup_add : 'a semigroup_add -> 'a plus;

type 'a cancel_semigroup_add =
  {semigroup_add_cancel_semigroup_add : 'a semigroup_add};
val semigroup_add_cancel_semigroup_add = #semigroup_add_cancel_semigroup_add :
  'a cancel_semigroup_add -> 'a semigroup_add;

type 'a ab_semigroup_add = {semigroup_add_ab_semigroup_add : 'a semigroup_add};
val semigroup_add_ab_semigroup_add = #semigroup_add_ab_semigroup_add :
  'a ab_semigroup_add -> 'a semigroup_add;

type 'a cancel_ab_semigroup_add =
  {ab_semigroup_add_cancel_ab_semigroup_add : 'a ab_semigroup_add,
    cancel_semigroup_add_cancel_ab_semigroup_add : 'a cancel_semigroup_add};
val ab_semigroup_add_cancel_ab_semigroup_add =
  #ab_semigroup_add_cancel_ab_semigroup_add :
  'a cancel_ab_semigroup_add -> 'a ab_semigroup_add;
val cancel_semigroup_add_cancel_ab_semigroup_add =
  #cancel_semigroup_add_cancel_ab_semigroup_add :
  'a cancel_ab_semigroup_add -> 'a cancel_semigroup_add;

type 'a monoid_add =
  {semigroup_add_monoid_add : 'a semigroup_add, zero_monoid_add : 'a zero};
val semigroup_add_monoid_add = #semigroup_add_monoid_add :
  'a monoid_add -> 'a semigroup_add;
val zero_monoid_add = #zero_monoid_add : 'a monoid_add -> 'a zero;

type 'a comm_monoid_add =
  {ab_semigroup_add_comm_monoid_add : 'a ab_semigroup_add,
    monoid_add_comm_monoid_add : 'a monoid_add};
val ab_semigroup_add_comm_monoid_add = #ab_semigroup_add_comm_monoid_add :
  'a comm_monoid_add -> 'a ab_semigroup_add;
val monoid_add_comm_monoid_add = #monoid_add_comm_monoid_add :
  'a comm_monoid_add -> 'a monoid_add;

type 'a cancel_comm_monoid_add =
  {cancel_ab_semigroup_add_cancel_comm_monoid_add : 'a cancel_ab_semigroup_add,
    comm_monoid_add_cancel_comm_monoid_add : 'a comm_monoid_add};
val cancel_ab_semigroup_add_cancel_comm_monoid_add =
  #cancel_ab_semigroup_add_cancel_comm_monoid_add :
  'a cancel_comm_monoid_add -> 'a cancel_ab_semigroup_add;
val comm_monoid_add_cancel_comm_monoid_add =
  #comm_monoid_add_cancel_comm_monoid_add :
  'a cancel_comm_monoid_add -> 'a comm_monoid_add;

type 'a mult_zero = {times_mult_zero : 'a times, zero_mult_zero : 'a zero};
val times_mult_zero = #times_mult_zero : 'a mult_zero -> 'a times;
val zero_mult_zero = #zero_mult_zero : 'a mult_zero -> 'a zero;

type 'a semigroup_mult = {times_semigroup_mult : 'a times};
val times_semigroup_mult = #times_semigroup_mult :
  'a semigroup_mult -> 'a times;

type 'a semiring =
  {ab_semigroup_add_semiring : 'a ab_semigroup_add,
    semigroup_mult_semiring : 'a semigroup_mult};
val ab_semigroup_add_semiring = #ab_semigroup_add_semiring :
  'a semiring -> 'a ab_semigroup_add;
val semigroup_mult_semiring = #semigroup_mult_semiring :
  'a semiring -> 'a semigroup_mult;

type 'a semiring_0 =
  {comm_monoid_add_semiring_0 : 'a comm_monoid_add,
    mult_zero_semiring_0 : 'a mult_zero, semiring_semiring_0 : 'a semiring};
val comm_monoid_add_semiring_0 = #comm_monoid_add_semiring_0 :
  'a semiring_0 -> 'a comm_monoid_add;
val mult_zero_semiring_0 = #mult_zero_semiring_0 :
  'a semiring_0 -> 'a mult_zero;
val semiring_semiring_0 = #semiring_semiring_0 : 'a semiring_0 -> 'a semiring;

type 'a semiring_0_cancel =
  {cancel_comm_monoid_add_semiring_0_cancel : 'a cancel_comm_monoid_add,
    semiring_0_semiring_0_cancel : 'a semiring_0};
val cancel_comm_monoid_add_semiring_0_cancel =
  #cancel_comm_monoid_add_semiring_0_cancel :
  'a semiring_0_cancel -> 'a cancel_comm_monoid_add;
val semiring_0_semiring_0_cancel = #semiring_0_semiring_0_cancel :
  'a semiring_0_cancel -> 'a semiring_0;

type 'a group_add =
  {cancel_semigroup_add_group_add : 'a cancel_semigroup_add,
    minus_group_add : 'a minus, monoid_add_group_add : 'a monoid_add,
    uminus_group_add : 'a uminus};
val cancel_semigroup_add_group_add = #cancel_semigroup_add_group_add :
  'a group_add -> 'a cancel_semigroup_add;
val minus_group_add = #minus_group_add : 'a group_add -> 'a minus;
val monoid_add_group_add = #monoid_add_group_add :
  'a group_add -> 'a monoid_add;
val uminus_group_add = #uminus_group_add : 'a group_add -> 'a uminus;

type 'a ab_group_add =
  {cancel_comm_monoid_add_ab_group_add : 'a cancel_comm_monoid_add,
    group_add_ab_group_add : 'a group_add};
val cancel_comm_monoid_add_ab_group_add = #cancel_comm_monoid_add_ab_group_add :
  'a ab_group_add -> 'a cancel_comm_monoid_add;
val group_add_ab_group_add = #group_add_ab_group_add :
  'a ab_group_add -> 'a group_add;

type 'a ring =
  {ab_group_add_ring : 'a ab_group_add,
    semiring_0_cancel_ring : 'a semiring_0_cancel};
val ab_group_add_ring = #ab_group_add_ring : 'a ring -> 'a ab_group_add;
val semiring_0_cancel_ring = #semiring_0_cancel_ring :
  'a ring -> 'a semiring_0_cancel;

val plus_int = {plus = plus_inta} : int plus;

val semigroup_add_int = {plus_semigroup_add = plus_int} : int semigroup_add;

val cancel_semigroup_add_int =
  {semigroup_add_cancel_semigroup_add = semigroup_add_int} :
  int cancel_semigroup_add;

val ab_semigroup_add_int = {semigroup_add_ab_semigroup_add = semigroup_add_int}
  : int ab_semigroup_add;

val cancel_ab_semigroup_add_int =
  {ab_semigroup_add_cancel_ab_semigroup_add = ab_semigroup_add_int,
    cancel_semigroup_add_cancel_ab_semigroup_add = cancel_semigroup_add_int}
  : int cancel_ab_semigroup_add;

val zero_int = {zero = Zero_int} : int zero;

val monoid_add_int =
  {semigroup_add_monoid_add = semigroup_add_int, zero_monoid_add = zero_int} :
  int monoid_add;

val comm_monoid_add_int =
  {ab_semigroup_add_comm_monoid_add = ab_semigroup_add_int,
    monoid_add_comm_monoid_add = monoid_add_int}
  : int comm_monoid_add;

val cancel_comm_monoid_add_int =
  {cancel_ab_semigroup_add_cancel_comm_monoid_add = cancel_ab_semigroup_add_int,
    comm_monoid_add_cancel_comm_monoid_add = comm_monoid_add_int}
  : int cancel_comm_monoid_add;

val times_int = {timesa = times_inta} : int times;

val mult_zero_int = {times_mult_zero = times_int, zero_mult_zero = zero_int} :
  int mult_zero;

val semigroup_mult_int = {times_semigroup_mult = times_int} :
  int semigroup_mult;

val semiring_int =
  {ab_semigroup_add_semiring = ab_semigroup_add_int,
    semigroup_mult_semiring = semigroup_mult_int}
  : int semiring;

val semiring_0_int =
  {comm_monoid_add_semiring_0 = comm_monoid_add_int,
    mult_zero_semiring_0 = mult_zero_int, semiring_semiring_0 = semiring_int}
  : int semiring_0;

val semiring_0_cancel_int =
  {cancel_comm_monoid_add_semiring_0_cancel = cancel_comm_monoid_add_int,
    semiring_0_semiring_0_cancel = semiring_0_int}
  : int semiring_0_cancel;

val uminus_int = {uminus = uminus_inta} : int uminus;

val minus_int = {minus = minus_inta} : int minus;

val group_add_int =
  {cancel_semigroup_add_group_add = cancel_semigroup_add_int,
    minus_group_add = minus_int, monoid_add_group_add = monoid_add_int,
    uminus_group_add = uminus_int}
  : int group_add;

val ab_group_add_int =
  {cancel_comm_monoid_add_ab_group_add = cancel_comm_monoid_add_int,
    group_add_ab_group_add = group_add_int}
  : int ab_group_add;

val ring_int =
  {ab_group_add_ring = ab_group_add_int,
    semiring_0_cancel_ring = semiring_0_cancel_int}
  : int ring;

datatype nat = Zero_nat | Suc of nat;

fun equal_nata Zero_nat (Suc x2) = false
  | equal_nata (Suc x2) Zero_nat = false
  | equal_nata (Suc x2) (Suc y2) = equal_nata x2 y2
  | equal_nata Zero_nat Zero_nat = true;

val equal_nat = {equal = equal_nata} : nat equal;

val zero_nat = {zero = Zero_nat} : nat zero;

fun less_eq_nat (Suc m) n = less_nat m n
  | less_eq_nat Zero_nat n = true
and less_nat m (Suc n) = less_eq_nat m n
  | less_nat n Zero_nat = false;

type 'a ord = {less_eq : 'a -> 'a -> bool, less : 'a -> 'a -> bool};
val less_eq = #less_eq : 'a ord -> 'a -> 'a -> bool;
val less = #less : 'a ord -> 'a -> 'a -> bool;

val ord_nat = {less_eq = less_eq_nat, less = less_nat} : nat ord;

type 'a preorder = {ord_preorder : 'a ord};
val ord_preorder = #ord_preorder : 'a preorder -> 'a ord;

type 'a order = {preorder_order : 'a preorder};
val preorder_order = #preorder_order : 'a order -> 'a preorder;

val preorder_nat = {ord_preorder = ord_nat} : nat preorder;

val order_nat = {preorder_order = preorder_nat} : nat order;

type 'a linpreorder = {preorder_linpreorder : 'a preorder};
val preorder_linpreorder = #preorder_linpreorder :
  'a linpreorder -> 'a preorder;

type 'a linorder =
  {linpreorder_linorder : 'a linpreorder, order_linorder : 'a order};
val linpreorder_linorder = #linpreorder_linorder :
  'a linorder -> 'a linpreorder;
val order_linorder = #order_linorder : 'a linorder -> 'a order;

val linpreorder_nat = {preorder_linpreorder = preorder_nat} : nat linpreorder;

val linorder_nat =
  {linpreorder_linorder = linpreorder_nat, order_linorder = order_nat} :
  nat linorder;

fun compare_nat (Suc n) (Suc m) = compare_nat n m
  | compare_nat (Suc n) Zero_nat = General.GREATER
  | compare_nat Zero_nat (Suc m) = General.LESS
  | compare_nat Zero_nat Zero_nat = General.EQUAL;

type 'a linpreorder_compare =
  {linpreorder_linpreorder_compare : 'a linpreorder,
    compare : 'a -> 'a -> General.order};
val linpreorder_linpreorder_compare = #linpreorder_linpreorder_compare :
  'a linpreorder_compare -> 'a linpreorder;
val compare = #compare : 'a linpreorder_compare -> 'a -> 'a -> General.order;

type 'a linorder_compare =
  {linpreorder_compare_linorder_compare : 'a linpreorder_compare,
    linorder_linorder_compare : 'a linorder};
val linpreorder_compare_linorder_compare = #linpreorder_compare_linorder_compare
  : 'a linorder_compare -> 'a linpreorder_compare;
val linorder_linorder_compare = #linorder_linorder_compare :
  'a linorder_compare -> 'a linorder;

val linpreorder_compare_nat =
  {linpreorder_linpreorder_compare = linpreorder_nat, compare = compare_nat} :
  nat linpreorder_compare;

val linorder_compare_nat =
  {linpreorder_compare_linorder_compare = linpreorder_compare_nat,
    linorder_linorder_compare = linorder_nat}
  : nat linorder_compare;

fun eq A_ a b = equal A_ a b;

fun equal_proda A_ B_ (x1, x2) (y1, y2) = eq A_ x1 y1 andalso eq B_ x2 y2;

fun equal_prod A_ B_ = {equal = equal_proda A_ B_} : ('a * 'b) equal;

fun less_eq_prod A_ B_ (x1, y1) (x2, y2) =
  less A_ x1 x2 orelse less_eq A_ x1 x2 andalso less_eq B_ y1 y2;

fun less_prod A_ B_ (x1, y1) (x2, y2) =
  less A_ x1 x2 orelse less_eq A_ x1 x2 andalso less B_ y1 y2;

fun ord_prod A_ B_ = {less_eq = less_eq_prod A_ B_, less = less_prod A_ B_} :
  ('a * 'b) ord;

fun preorder_prod A_ B_ =
  {ord_preorder = ord_prod (ord_preorder A_) (ord_preorder B_)} :
  ('a * 'b) preorder;

fun order_prod A_ B_ =
  {preorder_order = preorder_prod (preorder_order A_) (preorder_order B_)} :
  ('a * 'b) order;

fun uminus_comparisona General.LESS = General.GREATER
  | uminus_comparisona General.EQUAL = General.EQUAL
  | uminus_comparisona General.GREATER = General.LESS;

val uminus_comparison = {uminus = uminus_comparisona} : General.order uminus;

fun less_eq_list (A1_, A2_) (x :: xs) (y :: ys) =
  less ((ord_preorder o preorder_order) A2_) x y orelse
    eq A1_ x y andalso less_eq_list (A1_, A2_) xs ys
  | less_eq_list (A1_, A2_) [] xs = true
  | less_eq_list (A1_, A2_) (x :: xs) [] = false;

datatype 'a nat_mapping_sparse = Abs_nat_mapping_sparse of (nat * 'a) list;

fun rep_nat_mapping_sparse A_ (Abs_nat_mapping_sparse x) = x;

fun less_eq_nat_mapping_sparse (A1_, A2_, A3_) xa xc =
  less_eq_list
    (equal_prod equal_nat A2_, order_prod order_nat (order_linorder A3_))
    (rep_nat_mapping_sparse A1_ xa) (rep_nat_mapping_sparse A1_ xc);

datatype 'a nat_mapping_dense = Abs_nat_mapping_dense of 'a list;

fun rep_nat_mapping_dense A_ (Abs_nat_mapping_dense x) = x;

fun less_eq_nat_mapping_dense (A1_, A2_, A3_) xa xc =
  less_eq_list (A2_, order_linorder A3_) (rep_nat_mapping_dense A1_ xa)
    (rep_nat_mapping_dense A1_ xc);

datatype nibble = Nibble0 | Nibble1 | Nibble2 | Nibble3 | Nibble4 | Nibble5 |
  Nibble6 | Nibble7 | Nibble8 | Nibble9 | NibbleA | NibbleB | NibbleC | NibbleD
  | NibbleE | NibbleF;

datatype 'a nat_mapping = Dense of 'a nat_mapping_dense |
  Sparse of 'a nat_mapping_sparse;

datatype char = Char of nibble * nibble;

fun less_eq_nat_mapping (A1_, A2_, A3_) (Sparse x) (Sparse y) =
  less_eq_nat_mapping_sparse (A1_, A2_, A3_) x y
  | less_eq_nat_mapping (A1_, A2_, A3_) (Dense x) (Dense y) =
    less_eq_nat_mapping_dense (A1_, A2_, A3_) x y
  | less_eq_nat_mapping (A1_, A2_, A3_) x y =
    (raise Fail
      "order comparison between different representations unsupported")
      (fn _ => less_eq_nat_mapping (A1_, A2_, A3_) x y);

fun less_list (A1_, A2_) (x :: xs) (y :: ys) =
  less ((ord_preorder o preorder_order) A2_) x y orelse
    eq A1_ x y andalso less_list (A1_, A2_) xs ys
  | less_list (A1_, A2_) [] (x :: xs) = true
  | less_list (A1_, A2_) xs [] = false;

fun less_nat_mapping_sparse (A1_, A2_, A3_) xa xc =
  less_list
    (equal_prod equal_nat A2_, order_prod order_nat (order_linorder A3_))
    (rep_nat_mapping_sparse A1_ xa) (rep_nat_mapping_sparse A1_ xc);

fun less_nat_mapping_dense (A1_, A2_, A3_) xa xc =
  less_list (A2_, order_linorder A3_) (rep_nat_mapping_dense A1_ xa)
    (rep_nat_mapping_dense A1_ xc);

fun less_nat_mapping (A1_, A2_, A3_) (Sparse x) (Sparse y) =
  less_nat_mapping_sparse (A1_, A2_, A3_) x y
  | less_nat_mapping (A1_, A2_, A3_) (Dense x) (Dense y) =
    less_nat_mapping_dense (A1_, A2_, A3_) x y
  | less_nat_mapping (A1_, A2_, A3_) x y =
    (raise Fail
      "strict order comparison between different representations unsupported")
      (fn _ => less_nat_mapping (A1_, A2_, A3_) x y);

fun ord_nat_mapping (A1_, A2_, A3_) =
  {less_eq = less_eq_nat_mapping (A1_, A2_, A3_),
    less = less_nat_mapping (A1_, A2_, A3_)}
  : 'a nat_mapping ord;

fun equal_list A_ [] (x21 :: x22) = false
  | equal_list A_ (x21 :: x22) [] = false
  | equal_list A_ (x21 :: x22) (y21 :: y22) =
    eq A_ x21 y21 andalso equal_list A_ x22 y22
  | equal_list A_ [] [] = true;

fun equal_nat_mapping_sparse (A1_, A2_) xa xc =
  equal_list (equal_prod equal_nat A2_) (rep_nat_mapping_sparse A1_ xa)
    (rep_nat_mapping_sparse A1_ xc);

fun equal_nat_mapping_dense (A1_, A2_) xa xc =
  equal_list A2_ (rep_nat_mapping_dense A1_ xa) (rep_nat_mapping_dense A1_ xc);

fun equal_nat_mapping (A1_, A2_) (Sparse x) (Sparse y) =
  equal_nat_mapping_sparse (A1_, A2_) x y
  | equal_nat_mapping (A1_, A2_) (Dense x) (Dense y) =
    equal_nat_mapping_dense (A1_, A2_) x y
  | equal_nat_mapping (A1_, A2_) x y =
    (raise Fail
      "equality comparison between different representations unsupported")
      (fn _ => equal_nat_mapping (A1_, A2_) x y);

datatype 'a poly_rec = Coeff of 'a | Powers of 'a poly_rec nat_mapping;

fun zero_poly_reca A_ = Coeff (zero A_);

fun zero_poly_rec A_ = {zero = zero_poly_reca A_} : 'a poly_rec zero;

fun equal_poly_rec (A1_, A2_) = {equal = equal_poly_reca (A1_, A2_)} :
  'a poly_rec equal
and equal_poly_reca (A1_, A2_) (Coeff x1) (Powers x2) = false
  | equal_poly_reca (A1_, A2_) (Powers x2) (Coeff x1) = false
  | equal_poly_reca (A1_, A2_) (Powers x2) (Powers y2) =
    equal_nat_mapping (zero_poly_rec A1_, equal_poly_rec (A1_, A2_)) x2 y2
  | equal_poly_reca (A1_, A2_) (Coeff x1) (Coeff y1) = eq A2_ x1 y1;

fun comparator_of_le A_ x y =
  (if less_eq A_ x y
    then (if less_eq A_ y x then General.EQUAL else General.LESS)
    else General.GREATER);

fun filter_map2 f ((k, v) :: xs) =
  (case f k v of NONE => filter_map2 f xs
    | SOME w => (k, w) :: filter_map2 f xs)
  | filter_map2 f [] = [];

fun oa_zip_with cmp f g h ((ka, va) :: xs) ((k, v) :: ys) =
  (case cmp ka k
    of General.LESS =>
      (case f ka va of NONE => oa_zip_with cmp f g h xs ((k, v) :: ys)
        | SOME w => (ka, w) :: oa_zip_with cmp f g h xs ((k, v) :: ys))
    | General.EQUAL =>
      (case h ka va v of NONE => oa_zip_with cmp f g h xs ys
        | SOME w => (ka, w) :: oa_zip_with cmp f g h xs ys)
    | General.GREATER =>
      (case g k v of NONE => oa_zip_with cmp f g h ((ka, va) :: xs) ys
        | SOME w => (k, w) :: oa_zip_with cmp f g h ((ka, va) :: xs) ys))
  | oa_zip_with cmp f g h xs [] = filter_map2 f xs
  | oa_zip_with cmp f g h [] ys = filter_map2 g ys;

fun zip_with_sparse_raw A_ B_ C_ (D1_, D2_) f xs ys =
  oa_zip_with
    (comparator_of_le ((ord_preorder o preorder_order o order_linorder) A_))
    (fn k => fn v =>
      let
        val z = f k v (zero C_);
      in
        (if eq D2_ z (zero D1_) then NONE else SOME z)
      end)
    (fn k => fn v =>
      let
        val z = f k (zero B_) v;
      in
        (if eq D2_ z (zero D1_) then NONE else SOME z)
      end)
    (fn k => fn v => fn va =>
      let
        val z = f k v va;
      in
        (if eq D2_ z (zero D1_) then NONE else SOME z)
      end)
    xs ys;

fun zip_with_sparse B_ C_ (A1_, A2_) xc xd xe =
  Abs_nat_mapping_sparse
    (zip_with_sparse_raw linorder_nat B_ C_ (A1_, A2_) xc
      (rep_nat_mapping_sparse B_ xd) (rep_nat_mapping_sparse C_ xe));

fun apply0 (A1_, A2_) B_ f x = (if eq A2_ x (zero A1_) then zero B_ else f x);

fun null [] = true
  | null (x :: xs) = false;

fun strip_map (A1_, A2_) (B1_, B2_) f n [] = []
  | strip_map (A1_, A2_) (B1_, B2_) f n (x :: xs) =
    let
      val ys = strip_map (A1_, A2_) (B1_, B2_) f (Suc n) xs;
      val y = apply0 (A1_, A2_) B1_ (f n) x;
    in
      (if null ys andalso eq B2_ y (zero B1_) then [] else y :: ys)
    end;

fun apply0_2 (A1_, A2_) (B1_, B2_) C_ f x y =
  (if eq A2_ x (zero A1_) andalso eq B2_ y (zero B1_) then zero C_ else f x y);

fun zip_with_dense_raw (A1_, A2_) (B1_, B2_) (C1_, C2_) f n [] ys =
  strip_map (B1_, B2_) (C1_, C2_) (fn na => f na (zero A1_)) n ys
  | zip_with_dense_raw (A1_, A2_) (B1_, B2_) (C1_, C2_) f n xs [] =
    strip_map (A1_, A2_) (C1_, C2_) (fn na => fn x => f na x (zero B1_)) n xs
  | zip_with_dense_raw (A1_, A2_) (B1_, B2_) (C1_, C2_) f n (x :: xs) (y :: ys)
    = let
        val zs =
          zip_with_dense_raw (A1_, A2_) (B1_, B2_) (C1_, C2_) f (Suc n) xs ys;
        val z = apply0_2 (A1_, A2_) (B1_, B2_) C1_ (f n) x y;
      in
        (if null zs andalso eq C2_ z (zero C1_) then [] else z :: zs)
      end;

fun zip_with_dense (B1_, B2_) (C1_, C2_) (A1_, A2_) xc xd xe =
  Abs_nat_mapping_dense
    (zip_with_dense_raw (B1_, B2_) (C1_, C2_) (A1_, A2_) xc Zero_nat
      (rep_nat_mapping_dense B1_ xd) (rep_nat_mapping_dense C1_ xe));

fun plus_nat_mapping (A1_, A2_) (Sparse xs) (Sparse ys) =
  Sparse
    (zip_with_sparse (zero_monoid_add A1_) (zero_monoid_add A1_)
      (zero_monoid_add A1_, A2_)
      (fn _ => plus ((plus_semigroup_add o semigroup_add_monoid_add) A1_)) xs
      ys)
  | plus_nat_mapping (A1_, A2_) (Dense xs) (Dense ys) =
    Dense (zip_with_dense (zero_monoid_add A1_, A2_) (zero_monoid_add A1_, A2_)
            (zero_monoid_add A1_, A2_)
            (fn _ => plus ((plus_semigroup_add o semigroup_add_monoid_add) A1_))
            xs ys);

fun single_sparse (A1_, A2_) xb xc =
  Abs_nat_mapping_sparse (if eq A2_ xc (zero A1_) then [] else [(xb, xc)]);

fun replicate Zero_nat x = []
  | replicate (Suc n) x = x :: replicate n x;

fun single_dense (A1_, A2_) xb xc =
  Abs_nat_mapping_dense
    (if eq A2_ xc (zero A1_) then [] else replicate xb (zero A1_) @ [xc]);

datatype implb = DENSE | SPARSE;

fun single (A1_, A2_) SPARSE k v = Sparse (single_sparse (A1_, A2_) k v)
  | single (A1_, A2_) DENSE k v = Dense (single_dense (A1_, A2_) k v);

fun implT A_ (Sparse s) = SPARSE
  | implT A_ (Dense d) = DENSE;

fun plus_poly_rec (A1_, A2_) = {plus = plus_poly_reca (A1_, A2_)} :
  'a poly_rec plus
and semigroup_add_poly_rec (A1_, A2_) =
  {plus_semigroup_add = plus_poly_rec (A1_, A2_)} : 'a poly_rec semigroup_add
and monoid_add_poly_rec (A1_, A2_) =
  {semigroup_add_monoid_add = semigroup_add_poly_rec (A1_, A2_),
    zero_monoid_add = zero_poly_rec (zero_monoid_add A1_)}
  : 'a poly_rec monoid_add
and plus_poly_reca (A1_, A2_) (Powers ps) (Coeff y) =
  Powers
    (plus_nat_mapping
      (monoid_add_poly_rec (A1_, A2_),
        equal_poly_rec (zero_monoid_add A1_, A2_))
      ps (single
           (zero_poly_rec (zero_monoid_add A1_),
             equal_poly_rec (zero_monoid_add A1_, A2_))
           (implT (zero_poly_rec (zero_monoid_add A1_)) ps) Zero_nat (Coeff y)))
  | plus_poly_reca (A1_, A2_) (Coeff x) (Powers qs) =
    Powers
      (plus_nat_mapping
        (monoid_add_poly_rec (A1_, A2_),
          equal_poly_rec (zero_monoid_add A1_, A2_))
        (single
          (zero_poly_rec (zero_monoid_add A1_),
            equal_poly_rec (zero_monoid_add A1_, A2_))
          (implT (zero_poly_rec (zero_monoid_add A1_)) qs) Zero_nat (Coeff x))
        qs)
  | plus_poly_reca (A1_, A2_) (Powers ps) (Powers qs) =
    Powers
      (plus_nat_mapping
        (monoid_add_poly_rec (A1_, A2_),
          equal_poly_rec (zero_monoid_add A1_, A2_))
        ps qs)
  | plus_poly_reca (A1_, A2_) (Coeff x) (Coeff y) =
    Coeff (plus ((plus_semigroup_add o semigroup_add_monoid_add) A1_) x y);

datatype monom_order = Rlex_mo | Lex_mo;

datatype 'a poly_distr =
  Poly_distr_of_raw of ((nat nat_mapping * 'a) list * monom_order);

datatype 'a mpoly = Distr of 'a poly_distr | Rec of 'a poly_rec;

datatype impla = RLEX | LEX;

datatype impl = REC of (nat -> implb) | DISTR of impla;

datatype ('b, 'a) ignore_arg = Abs_ignore_arg of ('b -> 'a);

fun id x = (fn xa => xa) x;

fun foldr f [] = id
  | foldr f (x :: xs) = f x o foldr f xs;

fun map fi [] = []
  | map fi (x21a :: x22) = fi x21a :: map fi x22;

fun foldr_sparse A_ x xc =
  foldr (fn (a, b) => x a b) (rep_nat_mapping_sparse A_ xc);

*} ML {*
(*/---------- prepare investigation of foldr ---------------------------------------------------\*)
fun dest_nat Zero_nat = 0
  | dest_nat (Suc n') = 1 + dest_nat n';
fun nat_str n = n |> dest_nat |> string_of_int |> curry op ^ "#";
fun nat_int n = n |> dest_nat;

if nat_str (Suc (Suc Zero_nat)) = "#2" then () else error "nat_str changed";
if nat_int (Suc (Suc Zero_nat)) = 2 then () else error "nat_int changed";

(* see ~~ src/HOL/Num.thy *)
fun dest_num One = 1
  | dest_num (Bit0 n') = 2 * dest_num n'
  | dest_num (Bit1 n') = 2 * dest_num n' + 1;

if dest_num (Bit0 (Bit1 One)) = 6 then () else error "dest_num changed";

fun int_str (Pos n) = n |> dest_num |> string_of_int |> curry op ^ "" 
  | int_str Zero_int = "0"
  | int_str (Neg n) = n |> dest_num |> string_of_int |> curry op ^ "~";

if int_str (Pos (Bit0 (Bit1 One))) = "6" then () else error "int_str Pos changed";
if int_str (Neg (Bit0 (Bit1 One))) = "~6" then () else error "int_str Neg changed";

fun poly_str (Coeff c) = "Coeff " ^ int_str c
  | poly_str (Powers (Dense (Abs_nat_mapping_dense ps))) =
      "Powers [" ^ (commas (map poly_str ps)) ^ "]"
  | poly_str _ = error "poly_str only implemented for Rec Dense";

if poly_str (Powers (Dense (Abs_nat_mapping_dense [
     Powers (Dense (Abs_nat_mapping_dense [
       Coeff Zero_int, Coeff (Pos (Bit0 (Bit0 (Bit0 One))))])), 
     Coeff (Pos (Bit0 (Bit1 (Bit0 One))))]))) = "Powers [Powers [Coeff 0, Coeff 8], Coeff 10]"
then () else error "poly_str changed";

fun polys_str ps = "[" ^ (commas (map poly_str ps)) ^ "]"

fun nat_m_str (Dense (Abs_nat_mapping_dense ps)) = 
      "Dense (Abs_nat_map.. " ^ (commas (map poly_str ps)) ^ ")"
  | nat_m_str _  = error "nat_m_str only implemented for Rec Dense";

if nat_m_str (Dense (Abs_nat_mapping_dense [
     Powers (Dense (Abs_nat_mapping_dense [
       Coeff Zero_int, Coeff (Pos (Bit0 (Bit0 One)))])), 
     Coeff (Pos (Bit1 (Bit0 One)))])) 
  = "Dense (Abs_nat_map.. Powers [Coeff 0, Coeff 4], Coeff 5)"
then () else error "nat_m_str changed";

fun indent 0 mark = mark
  | indent n mark = "   " ^ indent (n - 1) mark;

if indent 0 "###" = "###" then () else error "indent 0 ### changed";
if indent 1 "###" = "   ###" then () else error "indent 1 ### changed";
if indent 0 "#####" = "#####" then () else error "indent 0 ##### changed";
(*\---------- prepare investigation of foldr ---------------------------------------------------/*)

fun foldr_dense_raw (*1*) (A1_, A2_) f n [] b = b
  | foldr_dense_raw (*2*) (A1_, A2_) f n (x :: xs) b =
    (if eq A2_ x (zero A1_) then id else f n x)
      (foldr_dense_raw (A1_, A2_) f (Suc n) xs b);

fun foldr_dense (A1_, A2_) x xc =
  foldr_dense_raw (A1_, A2_) x Zero_nat (rep_nat_mapping_dense A1_ xc);

fun foldra (A1_, A2_) f (Sparse xs) z = foldr_sparse A1_ f xs z
  | foldra (A1_, A2_) f (Dense xs) z = foldr_dense (A1_, A2_) f xs z;

fun plus_nat (Suc m) n = plus_nat m (Suc n)
  | plus_nat Zero_nat n = n;

fun apfst f (x, y) = (f x, y);

fun add_keys_sparse A_ xb xc =
  Abs_nat_mapping_sparse
    (map (apfst (plus_nat xb)) (rep_nat_mapping_sparse A_ xc));

fun add_keys_dense A_ xb xc =
  Abs_nat_mapping_dense
    (if null (rep_nat_mapping_dense A_ xc) then []
      else replicate xb (zero A_) @ rep_nat_mapping_dense A_ xc);

fun add_keys A_ n (Sparse xs) = Sparse (add_keys_sparse A_ n xs)
  | add_keys A_ n (Dense xs) = Dense (add_keys_dense A_ n xs);

fun minus_nat (Suc m) (Suc n) = minus_nat m n
  | minus_nat Zero_nat n = Zero_nat
  | minus_nat m Zero_nat = m;

val one_nat : nat = Suc Zero_nat;

fun mapp_sparse_raw A_ B_ C_ g xs = map (fn (k, v) => (k, g k v)) xs;

fun mapp_sparse B_ A_ xb xc =
  Abs_nat_mapping_sparse
    (mapp_sparse_raw linorder_nat B_ A_ xb (rep_nat_mapping_sparse B_ xc));

fun mapp_dense_raw (A1_, A2_) (B1_, B2_) g n [] = []
  | mapp_dense_raw (A1_, A2_) (B1_, B2_) g n (x :: xs) =
    let
      val zs = mapp_dense_raw (A1_, A2_) (B1_, B2_) g (Suc n) xs;
      val z = apply0 (A1_, A2_) B1_ (g n) x;
    in
      (if null zs andalso eq B2_ z (zero B1_) then [] else z :: zs)
    end;

fun mapp_dense (B1_, B2_) (A1_, A2_) xb xc =
  Abs_nat_mapping_dense
    (mapp_dense_raw (B1_, B2_) (A1_, A2_) xb Zero_nat
      (rep_nat_mapping_dense B1_ xc));

fun mapp (A1_, A2_) (B1_, B2_) f (Sparse xs) = Sparse (mapp_sparse A1_ B1_ f xs)
  | mapp (A1_, A2_) (B1_, B2_) f (Dense xs) =
    Dense (mapp_dense (A1_, A2_) (B1_, B2_) f xs);

fun inc_power_rec (A1_, A2_) impl Zero_nat (Coeff a) =
  (if eq A2_ a (zero A1_) then Coeff (zero A1_)
    else Powers
           (single (zero_poly_rec A1_, equal_poly_rec (A1_, A2_)) impl one_nat
             (Coeff a)))
  | inc_power_rec (A1_, A2_) uu Zero_nat (Powers ps) =
    Powers (add_keys (zero_poly_rec A1_) one_nat ps)
  | inc_power_rec (A1_, A2_) impl (Suc v) (Coeff a) =
    (if eq A2_ a (zero A1_) then Coeff (zero A1_)
      else Powers
             (single (zero_poly_rec A1_, equal_poly_rec (A1_, A2_)) impl one_nat
               (inc_power_rec (A1_, A2_) impl (minus_nat (Suc v) one_nat)
                 (Coeff a))))
  | inc_power_rec (A1_, A2_) impl (Suc v) (Powers ps) =
    Powers
      (mapp (zero_poly_rec A1_, equal_poly_rec (A1_, A2_))
        (zero_poly_rec A1_, equal_poly_rec (A1_, A2_))
        (fn _ => inc_power_rec (A1_, A2_) impl (minus_nat (Suc v) one_nat)) ps);

fun smult_rec (A1_, A2_, A3_) s (Coeff c) = Coeff (timesa A1_ s c)
  | smult_rec (A1_, A2_, A3_) s (Powers ps) =
    (if eq A3_ s (zero A2_) then Coeff (zero A2_)
      else Powers
             (mapp (zero_poly_rec A2_, equal_poly_rec (A2_, A3_))
               (zero_poly_rec A2_, equal_poly_rec (A2_, A3_))
               (fn _ => smult_rec (A1_, A2_, A3_) s) ps));

fun times (*1*) (A1_, A2_, A3_) uu (Coeff a) (Coeff b) = 
(writeln (indent (nat_int uu) "###" ^ " times (*1*): lev = " ^ nat_str uu ^ 
"  (Coeff " ^ int_str a ^ ") * (Coeff " ^ int_str b ^ 
") \<longrightarrow> (" ^ poly_str (Coeff (timesa A2_ a b)) ^ ")");
    Coeff (timesa A2_ a b)
)
  | times (*2*) (A1_, A2_, A3_) uv (Coeff a) (Powers qs) =
let val xxx = Powers
      (mapp (zero_poly_rec (zero_monoid_add A1_),
              equal_poly_rec (zero_monoid_add A1_, A3_))
        (zero_poly_rec (zero_monoid_add A1_),
          equal_poly_rec (zero_monoid_add A1_, A3_))
        (fn _ => smult_rec (A2_, zero_monoid_add A1_, A3_) a) qs)
in
(writeln (indent (nat_int uv) "###" ^ " times (*2*): lev = " ^ nat_str uv ^ 
"  (Coeff " ^ int_str a ^ ") * (" ^ poly_str (Powers qs) ^ ") \<longrightarrow> (" ^ poly_str xxx ^ ")");
    xxx
)
end
  | times (*3*) (A1_, A2_, A3_) uw (Powers ps) (Coeff b) =
let val xxx = Powers
      (mapp (zero_poly_rec (zero_monoid_add A1_),
              equal_poly_rec (zero_monoid_add A1_, A3_))
        (zero_poly_rec (zero_monoid_add A1_),
          equal_poly_rec (zero_monoid_add A1_, A3_))
        (fn _ => smult_rec (A2_, zero_monoid_add A1_, A3_) b) ps)
in
(writeln (indent (nat_int uw) "###" ^ " times (*3*): lev = " ^ nat_str uw ^ 
"  (" ^ poly_str (Powers ps) ^ ") * (Coeff " ^ int_str b ^ ") \<longrightarrow> (" ^ poly_str xxx ^ ")");
    xxx
)
end
  | times (*4*) (A1_, A2_, A3_) lev (Powers ps) (Powers v) =
let 
  val _ = writeln (indent (nat_int lev) "/##" ^ " times (*4*): lev = " ^ nat_str lev ^ 
"  (" ^ poly_str (Powers ps) ^ ") * (Coeff " ^ poly_str (Powers v) ^ ")...");
  val xxx = foldra
      (zero_poly_rec (zero_monoid_add A1_),
        equal_poly_rec (zero_monoid_add A1_, A3_))
      (fn n => fn a => fn p =>
  let val _ = writeln (indent (nat_int lev) " /####" ^ " \<lambda> (" ^ nat_str n ^ 
      ")  (" ^ poly_str a ^ ")  (" ^ poly_str p ^ "). ...")
      val prod = times (A1_, A2_, A3_) (Suc lev) a (Powers v)
      val inc = inc_power_rec (zero_monoid_add A1_, A3_)
              (implT (zero_poly_rec (zero_monoid_add A1_)) ps) lev p
      val sum = plus_poly_reca (A1_, A3_) prod inc
  in
    (writeln (indent (nat_int lev) " \\####" ^ " \<lambda> (" ^ nat_str n ^ 
      ")  (" ^ poly_str a ^ ")  (" ^ poly_str p ^ "). (" ^ 
      poly_str prod ^ ") + (" ^ poly_str inc ^ ") \<longrightarrow> (" ^ poly_str sum ^ ")");
          sum)
  end)
      ps (Coeff (zero (zero_monoid_add A1_)))
in
(writeln (indent (nat_int lev) "\\##" ^ " times (*4*): lev = " ^ nat_str lev ^ 
"  (" ^ poly_str (Powers ps) ^ ") * (Coeff " ^ poly_str (Powers v) ^ ") \<longrightarrow> (" ^ poly_str xxx ^ ")");
    xxx
)
end
;

*} text {* (* original *)
fun times (*1*) (A1_, A2_, A3_) uu (Coeff a) (Coeff b) = Coeff (timesa A2_ a b)
  | times (*2*) (A1_, A2_, A3_) uv (Coeff a) (Powers qs) =
    Powers
      (mapp (zero_poly_rec (zero_monoid_add A1_),
              equal_poly_rec (zero_monoid_add A1_, A3_))
        (zero_poly_rec (zero_monoid_add A1_),
          equal_poly_rec (zero_monoid_add A1_, A3_))
        (fn _ => smult_rec (A2_, zero_monoid_add A1_, A3_) a) qs)
  | times (*3*) (A1_, A2_, A3_) uw (Powers ps) (Coeff b) =
    Powers
      (mapp (zero_poly_rec (zero_monoid_add A1_),
              equal_poly_rec (zero_monoid_add A1_, A3_))
        (zero_poly_rec (zero_monoid_add A1_),
          equal_poly_rec (zero_monoid_add A1_, A3_))
        (fn _ => smult_rec (A2_, zero_monoid_add A1_, A3_) b) ps)
  | times (*4*) (A1_, A2_, A3_) lev (Powers ps) (Powers v) =
    foldra
      (zero_poly_rec (zero_monoid_add A1_),
        equal_poly_rec (zero_monoid_add A1_, A3_))
      (fn _ => fn a => fn p =>
        plus_poly_reca (A1_, A3_) (times (A1_, A2_, A3_) (Suc lev) a (Powers v))
          (inc_power_rec (zero_monoid_add A1_, A3_)
            (implT (zero_poly_rec (zero_monoid_add A1_)) ps) lev p))
      ps (Coeff (zero (zero_monoid_add A1_)));
*} ML {*



fun monom_distr_impl (A1_, A2_) mo m c =
  Poly_distr_of_raw (if eq A2_ c (zero A1_) then ([], mo) else ([(m, c)], mo));

fun monom_distr (A1_, A2_) mo m c = Distr (monom_distr_impl (A1_, A2_) mo m c);

fun monom_distr_ignore (A1_, A2_) = Abs_ignore_arg (monom_distr (A1_, A2_));

fun apply_ignore (Abs_ignore_arg x) = x;

fun switch_monom_order f RLEX = apply_ignore f Rlex_mo
  | switch_monom_order f LEX = apply_ignore f Lex_mo;

fun monom_distra (A1_, A2_) =
  switch_monom_order (monom_distr_ignore (A1_, A2_));

fun shift_rec (A1_, A2_) (Coeff x) n = Coeff x
  | shift_rec (A1_, A2_) (Powers ps) Zero_nat = Powers ps
  | shift_rec (A1_, A2_) (Powers ps) (Suc n) =
    Powers
      (single (zero_poly_rec A1_, equal_poly_rec (A1_, A2_))
        (implT (zero_poly_rec A1_) ps) Zero_nat
        (shift_rec (A1_, A2_) (Powers ps) n));

fun monom_rec (A1_, A2_) impl m c =
  (if eq A2_ c (zero A1_) then Coeff (zero A1_)
    else let
           val (a, b) =
             foldra (zero_nat, equal_nat)
               (fn v => fn n => fn (p, va) =>
                 (Powers
                    (single (zero_poly_rec A1_, equal_poly_rec (A1_, A2_))
                      (impl n) n (shift_rec (A1_, A2_) p (minus_nat va v))),
                   v))
               m (Coeff c, Zero_nat);
         in
           shift_rec (A1_, A2_) a b
         end);

fun monom (A1_, A2_, A3_) (DISTR mo) m c =
  monom_distra
    ((zero_mult_zero o mult_zero_semiring_0 o semiring_0_semiring_0_cancel o
       semiring_0_cancel_ring)
       A3_,
      A2_)
    mo m c
  | monom (A1_, A2_, A3_) (REC impl) m c =
    Rec (monom_rec
          ((zero_mult_zero o mult_zero_semiring_0 o
             semiring_0_semiring_0_cancel o semiring_0_cancel_ring)
             A3_,
            A2_)
          impl m c);

fun raw_of_poly_distr A_ (Poly_distr_of_raw x) = x;

fun equal_monom_order Rlex_mo Rlex_mo = true
  | equal_monom_order Rlex_mo Lex_mo = false
  | equal_monom_order Lex_mo Rlex_mo = false
  | equal_monom_order Lex_mo Lex_mo = true;

fun insort_by compare x [] = [x]
  | insort_by compare x (y :: ys) =
    (case compare x y of General.LESS => x :: y :: ys | General.EQUAL => y :: ys
      | General.GREATER => y :: insort_by compare x ys);

fun sort_by compare xs = foldr (insort_by compare) xs [];

fun compare_nat_mapping (A1_, A2_, A3_) =
  comparator_of_le (ord_nat_mapping (A2_, A3_, linorder_linorder_compare A1_));

fun monom_compare Rlex_mo =
  uminus_funa (uminus_fun uminus_comparison)
    (compare_nat_mapping (linorder_compare_nat, zero_nat, equal_nat))
  | monom_compare Lex_mo =
    compare_nat_mapping (linorder_compare_nat, zero_nat, equal_nat);

fun compare_vimage f compare x y = compare (f x) (f y);

fun fst (x1, x2) = x1;

fun plus_distr_raw (A1_, A2_, A3_) (p1, cmp1) (p2, cmp2) =
  (if equal_monom_order cmp1 cmp2
    then (oa_zip_with (monom_compare cmp1) (fn _ => SOME) (fn _ => SOME)
            (fn _ => fn x => fn y =>
              let
                val z = plus A1_ x y;
              in
                (if eq A3_ z (zero A2_) then NONE else SOME z)
              end)
            p1 p2,
           cmp1)
    else let
           val cmp = monom_compare cmp1;
           val p2a = sort_by (compare_vimage fst cmp) p2;
         in
           (oa_zip_with cmp (fn _ => SOME) (fn _ => SOME)
              (fn _ => fn x => fn y =>
                let
                  val z = plus A1_ x y;
                in
                  (if eq A3_ z (zero A2_) then NONE else SOME z)
                end)
              p1 p2a,
             cmp1)
         end);

fun plus_poly_distr (A1_, A2_) p q =
  Poly_distr_of_raw
    (plus_distr_raw
      ((plus_semigroup_add o semigroup_add_monoid_add) A1_, zero_monoid_add A1_,
        A2_)
      (raw_of_poly_distr (zero_monoid_add A1_) p)
      (raw_of_poly_distr (zero_monoid_add A1_) q));

fun plus_mpoly (A1_, A2_, A3_) (Rec p) (Rec q) =
  Rec (plus_poly_reca
        ((monoid_add_group_add o group_add_ab_group_add o ab_group_add_ring)
           A3_,
          A2_)
        p q)
  | plus_mpoly (A1_, A2_, A3_) (Distr p) (Distr q) =
    Distr (plus_poly_distr
            ((monoid_add_group_add o group_add_ab_group_add o ab_group_add_ring)
               A3_,
              A2_)
            p q);

val p2x3y : int mpoly =
  plus_mpoly (one_int, equal_int, ring_int)
    (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
      (single (zero_nat, equal_nat) DENSE one_nat one_nat) (Pos (Bit0 One)))
    (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
      (single (zero_nat, equal_nat) DENSE Zero_nat one_nat) (Pos (Bit1 One)));

val p4x5y : int mpoly =
  plus_mpoly (one_int, equal_int, ring_int)
    (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
      (single (zero_nat, equal_nat) DENSE one_nat one_nat)
      (Pos (Bit0 (Bit0 One))))
    (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
      (single (zero_nat, equal_nat) DENSE Zero_nat one_nat)
      (Pos (Bit1 (Bit0 One))));

fun times_poly_rec (A1_, A2_) =
  times ((monoid_add_comm_monoid_add o comm_monoid_add_semiring_0) A2_,
          (times_mult_zero o mult_zero_semiring_0) A2_, A1_)
    Zero_nat;

fun times_mpoly (A1_, A2_, A3_) (Rec p) (Rec q) =
  Rec (times_poly_rec
        (A2_, (semiring_0_semiring_0_cancel o semiring_0_cancel_ring) A3_) p q);

fun try_times p q = times_mpoly (one_int, equal_int, ring_int) p q;

(*end; struct Try_Times*)
*} 
subsubsection {* Mult. foldr step.test*}
declare[[ML_print_depth = 999]]
text {*
open Try_Times
*} ML {*
p2x3y = Rec (
  Powers (Dense (Abs_nat_mapping_dense 
    [Powers (Dense (Abs_nat_mapping_dense 
      [Coeff Zero_int, Coeff (Pos (Bit0 One))])), 
    Coeff (Pos (Bit1 One))])))
*} ML {*
try_times p2x3y p4x5y = Rec (
  Powers (Dense (Abs_nat_mapping_dense [
    Powers (Dense (Abs_nat_mapping_dense [
      Coeff Zero_int, Coeff (Pos (Bit0 (Bit0 (Bit0 One))))])), (* x^0.y^1.8*)
    Powers (Dense (Abs_nat_mapping_dense [
      Coeff (Pos (Bit0 (Bit1 (Bit0 One)))), Coeff (Pos (Bit0 (Bit0 (Bit1 One))))])),
      (* x^1.(y^0.10                      + y^1.12)*) 
    Coeff (Pos (Bit1 (Bit1 (Bit1 One))))])))                   (* x^2.y^0.15
= Powers [Powers [Coeff 0, Coeff 8], Powers [Coeff 10, Coeff 12], Coeff   15] ERROR

OK WOULD BE: x^0.(y^0.0  + y^1.0  + y^2.8)  + x^1.   (y^0.0  + y^1.22)  + x^2.y^0.15)
= Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 22], Coeff 15]*)
*} text {* 
(2.x + 3.y).(4.x + 5.y) trace created from ML-block above and copied from Output
         /## times (*4*): lev = #0  (Powers [Powers [Coeff 0, Coeff 2], Coeff 3]) * (Coeff Powers [Powers [Coeff 0, Coeff 4], Coeff 5])... 
          /#### \<lambda> (#1)  (Coeff 3)  (Coeff 0). ... 
            ### times (*2*): lev = #1  (Coeff 3) * (Powers [Powers [Coeff 0, Coeff 4], Coeff 5]) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 12], Coeff 15]) 
          \#### \<lambda> (#1)  (Coeff 3)  (Coeff 0). (Powers [Powers [Coeff 0, Coeff 12], Coeff 15]) + (Coeff 0) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 12], Coeff 15]) 
          /#### \<lambda> (#0)  (Powers [Coeff 0, Coeff 2])  (Powers [Powers [Coeff 0, Coeff 12], Coeff 15]). ... 
            /## times (*4*): lev = #1  (Powers [Coeff 0, Coeff 2]) * (Coeff Powers [Powers [Coeff 0, Coeff 4], Coeff 5])... 
             /#### \<lambda> (#1)  (Coeff 2)  (Coeff 0). ... 
               ### times (*2*): lev = #2  (Coeff 2) * (Powers [Powers [Coeff 0, Coeff 4], Coeff 5]) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 8], Coeff 10]) 
             \#### \<lambda> (#1)  (Coeff 2)  (Coeff 0). (Powers [Powers [Coeff 0, Coeff 8], Coeff 10]) + (Coeff 0) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 8], Coeff 10]) 
^^^identical to ML_Recursive_dense.thy
2nd round of foldr is missing, compare "(2.x + 3.y).(4.x + 5.y) trace" in ML_Recursive_dense.thy
2nd round of foldr is missing, compare "(2.x + 3.y).(4.x + 5.y) trace" in ML_Recursive_dense.thy
2nd round of foldr is missing, compare "(2.x + 3.y).(4.x + 5.y) trace" in ML_Recursive_dense.thy

            \## times (*4*): lev = #1  (Powers [Coeff 0, Coeff 2]) * (Coeff Powers [Powers [Coeff 0, Coeff 4], Coeff 5]) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 8], Coeff 10]) 
          \#### \<lambda> (#0)  (Powers [Coeff 0, Coeff 2])  (Powers [Powers [Coeff 0, Coeff 12], Coeff 15]). (Powers [Powers [Coeff 0, Coeff 8], Coeff 10]) + (Powers [Coeff 0, Powers [Coeff 0, Coeff 12], Coeff 15]) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 8], Powers [Coeff 10, Coeff 12], Coeff 15]) 
         \## times (*4*): lev = #0  (Powers [Powers [Coeff 0, Coeff 2], Coeff 3]) * (Coeff Powers [Powers [Coeff 0, Coeff 4], Coeff 5]) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 8], Powers [Coeff 10, Coeff 12], Coeff 15]) 
*} text {*1
*} ML {* 
"====== compare ML_Recursive_dense.thy: (t) OK check mult (2.x + 3.y) (4.x + 5.y): mf1 ..=";
"====== note that in ^^^^^^^^^^^^^^^^^ no Nat_Mapping, thus below 2 inital steps more ====";
"~~~~~~~~~ fun try_times, args:"; val (p, q) = (p2x3y, p4x5y);
"~~~~~~~~~ fun times_mpoly, args:"; val ((A1_, A2_, A3_), (Rec p), (Rec q)) = 
  ((one_int, equal_int, ring_int), p, q);
"~~~~~~ check the first induction step in times (Powers ps) q ~~~~~~~~~~~~~~~~~~~~~~~~~~~~";
"====== note that here is Nat_Mapping, thus no times_poly_rec_dense below ================";
(*legend
    mf1_result: folded fun with 2. list element
    mf0: folded fun with 1. list element
    mf0mf1_result: recursive descent from mf0, folded fun with 2. list element
    mf0mf0: recursive descent from mf0, folded fun with 1. list element *)
"~~~~~~~~~ fun times_poly_rec, args:"; val (A1_', A2_') = 
  ((A2_, (semiring_0_semiring_0_cancel o semiring_0_cancel_ring) A3_)(*, p, q*));
"~~m~~~~~~ fun times (*4*), args:"; val ((A1_'', A2_'', A3_''), lev, (Powers ps), (Powers v)) = 
  (((monoid_add_comm_monoid_add o comm_monoid_add_semiring_0) A2_',
    (times_mult_zero o mult_zero_semiring_0) A2_', A1_'), Zero_nat, p, q);
"~~~~~ fun foldra, args:"; val ((A1_, A2_)(*''' stopped due OK below*), f, (Dense xs), z) = 
  ((zero_poly_rec (zero_monoid_add A1_''), equal_poly_rec (zero_monoid_add A1_'', A3_'')),
  (fn _ => fn a => fn p =>                 
    plus_poly_reca (A1_'', A3_'') (times (A1_'', A2_'', A3_'') (Suc lev) a (Powers v))
      (inc_power_rec (zero_monoid_add A1_'', A3_'')
        (implT (zero_poly_rec (zero_monoid_add A1_'')) ps) lev p)) : nat -> int poly_rec -> int poly_rec -> int poly_rec ,
  ps,                         (Coeff (zero (zero_monoid_add A1_''))));
(*int poly_rec nat_mapping -> int poly_rec                         -> int poly_rec*);
"~~~~~ fun foldr_dense, args:"; val ((A1_ , A2_), x, xc) = ((A1_, A2_), f, xs (*z*));
"~~~~~ fun foldr_dense_raw (*2*), args:"; val ((A1_, A2_), f, n, (*x :: xs*) xxx, b) = 
  ((A1_, A2_), x, Zero_nat, (rep_nat_mapping_dense A1_ xc), z);
"~~mf1~~~~ fun (fn a => ..., args:"; val (_, a, p) = (n, nth xxx 1, b);
*} ML {*
n = Zero_nat; (*                       ^^^_^^^ !?!?!?!?!?!?!?!?!??!?!?!?!?!?!?!?!?!?!?!?!?!?*)
lev = Zero_nat;                             (* level of recursion in int poly_rec *)
a = Coeff (Pos (Bit1 One));                 (* nth ps = 1, right most list element, = Coeff 3 *)
p = Coeff Zero_int;                         (* init 2nd arg of foldr, = Coeff 0 *)
v = (Dense (Abs_nat_mapping_dense [         (* the multiplicand*)
  Powers (Dense (Abs_nat_mapping_dense [       (*= Powers [Powers [Coeff 0, Coeff 4], Coeff 5] *)
    Coeff Zero_int, Coeff (Pos (Bit0 (Bit0 One)))])), 
  Coeff (Pos (Bit1 (Bit0 One)))]): int poly_rec nat_mapping)
*} ML {*
if times (A1_'', A2_'', A3_'') (Suc lev) a (Powers v) 
  = (*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< mf1 , times <<<<<<<<<<<*)
  Powers (Dense (Abs_nat_mapping_dense [
    Powers (Dense (Abs_nat_mapping_dense [
      Coeff Zero_int, Coeff (Pos (Bit0 (Bit0 (Bit1 One))))])), 
    Coeff (Pos (Bit1 (Bit1 (Bit1 One))))]))
  (*Powers [Powers [Coeff 0, Coeff 12], Coeff 15] OK*)
then () else error "(2.x + 3.y).(4.x + 5.y): mf1 , times changed";
     (* inc_power_rec + args with indentation from above *)
                                     zero_monoid_add A1_''     = {zero = Zero_int};
                               zero (zero_monoid_add A1_'')    = Zero_int;
                              (Coeff (Zero_int))               = Coeff Zero_int;
                                                           lev = Zero_nat;
        (implT (zero_poly_rec (zero_monoid_add A1_'')) ps)     = DENSE;
*} ML {*
if    (inc_power_rec (zero_monoid_add A1_'', A3_'') 
        DENSE lev
          (Coeff Zero_int)) 
  = (*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< mf1 , inc_power_rec <<<*)
  Coeff Zero_int (* OK *)
then () else error "(2.x + 3.y).(4.x + 5.y): mf1 , inc_power_rec changed";
val mf1_result = f n a p;                   (* keep for further foldr *)
(*...= Powers [Powers [Coeff 0, Coeff 12], Coeff 15] OK *)
*} ML {*
"~~mf0~~~~ fun (fn a => ..., args:"; val (_, a, p) = (n, nth xxx 0, mf1_result);
*} ML {*
n = Zero_nat; (*                       ^^^_^^^ !?!?!?!?!?!?!?!?!??!?!?!?!?!?!?!?!?!?!?!?!?!?*)
lev = Zero_nat;                             (* level of recursion in int poly_rec *)
a = Powers (Dense (Abs_nat_mapping_dense [  (* = nth ps 0, next and last list element *)
  Coeff Zero_int, Coeff (Pos (Bit0 One))]));   (*= Powers [Coeff 0, Coeff 2] *)
p;                                          (* the intermediate result of foldr *)
                                               (* Powers [Powers [Coeff 0, Coeff 12], Coeff 15] *)
v;                                          (* the multiplicand *)
                                               (* Powers [Powers [Coeff 0, Coeff 4], Coeff 5] *)
*} ML {*
if times (A1_'', A2_'', A3_'') (Suc lev) a (Powers v) 
  = (*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< mf1 , times RECURSION <*)
  Powers (Dense (Abs_nat_mapping_dense [Powers (Dense (Abs_nat_mapping_dense [
    Coeff Zero_int, Coeff (Pos (Bit0 (Bit0 (Bit0 One))))])), Coeff (Pos (Bit0 (Bit1 (Bit0 One))))]))
(*Powers [Powers [
    Coeff 0       , Coeff 8                             ]  , Coeff  10                           ]*)
then () else error "(2.x + 3.y).(4.x + 5.y): mf0 , times changed ERROR";
(* OK would be: Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 10]] *)
*} ML {*
if inc_power_rec (zero_monoid_add A1_'', A3_'')
    (implT (zero_poly_rec (zero_monoid_add A1_'')) ps) lev p
  = (*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< mf0 , inc_power_rec <<<*)
  Powers (Dense (Abs_nat_mapping_dense [
    Coeff Zero_int, 
    Powers (Dense (Abs_nat_mapping_dense [
      Coeff Zero_int, Coeff (Pos (Bit0 (Bit0 (Bit1 One))))])), 
    Coeff (Pos (Bit1 (Bit1 (Bit1 One))))]))
(*..\<doteq> Powers [Coeff 0, Powers [Coeff 0, Coeff 12], Coeff 15] OK *)
then () else error "(2.x + 3.y).(4.x + 5.y): mf0 , inc_power_rec changed OK";
*} ML {*
val mf0_inc =                               (* keep for return at level 0 *)
  inc_power_rec (zero_monoid_add A1_'', A3_'')
    (implT (zero_poly_rec (zero_monoid_add A1_'')) ps) lev p
(*..\<doteq> Powers [Coeff 0, Powers [Coeff 0, Coeff 12], Coeff 15] OK *)
*} ML {*
(*!*)f n a p; (*Powers [Powers [Coeff 0, Coeff 8], Powers [Coeff 10, Coeff 12], Coeff 15] 
  !...RESULT OF foldr CALCULATED AUTOMATICIALLY: ########################################### ERROR

  ! OK WOULD BE: x^0.(y^0.0  + y^1.0  + y^2.8)  + x^1.   (y^0.0  + y^1.22)  + x^2.y^0.15)
  != Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 22], Coeff 15]*)
(* ... the final result, but we go INTO the RECURSION of times ===============================: *)
*} ML {*
"~~mf0m~~~ fun times (*4*), args:"; val ((A1_'', A2_'', A3_''), lev, (Powers ps), (Powers v)) = 
  (((monoid_add_comm_monoid_add o comm_monoid_add_semiring_0) A2_',
    (times_mult_zero o mult_zero_semiring_0) A2_', A1_'), Suc Zero_nat, a, q) (*<<<<<<<*);
"~~~~~ fun foldra, args:"; val ((A1_, A2_)(*''' stopped due OK below*), f, (Dense xs), z) = 
  ((zero_poly_rec (zero_monoid_add A1_''), equal_poly_rec (zero_monoid_add A1_'', A3_'')),
  (fn _ => fn a => fn p =>                 
    plus_poly_reca (A1_'', A3_'') (times (A1_'', A2_'', A3_'') (Suc lev) a (Powers v))
      (inc_power_rec (zero_monoid_add A1_'', A3_'')
        (implT (zero_poly_rec (zero_monoid_add A1_'')) ps) lev p)) : nat -> int poly_rec -> int poly_rec -> int poly_rec ,
  ps,                         (Coeff (zero (zero_monoid_add A1_''))));
(*int poly_rec nat_mapping -> int poly_rec                         -> int poly_rec*);
"~~~~~ fun foldr_dense, args:"; val ((A1_ , A2_), x, xc) = ((A1_, A2_), f, xs (*z*));
*} ML {*
(*/------- foldr_dense_raw goes only 1 round over [Coeff 0, Coeff 2], unlike ML_Recursive_dense-\*)
(*1st argument*)map poly_str (rep_nat_mapping_dense A1_ xc) = ["Coeff 0", "Coeff 2"];
(*2nd argument*)z = Coeff Zero_int;
val mf0m = foldr_dense_raw (A1_, A2_) x Zero_nat (rep_nat_mapping_dense A1_ xc) z;
poly_str mf0m = "Powers [Powers [Coeff 0, Coeff 8], Coeff 10]" (* 1st round OK, 2nd round ??? *);
(*-------- foldr_dense_raw with ---------vvvvvvvvvvvvvv----- doesnt run a second round ----------*)
val mf0m' = foldr_dense_raw (A1_, A2_) x (Suc Zero_nat) (rep_nat_mapping_dense A1_ xc) z;
poly_str mf0m' = "Powers [Powers [Coeff 0, Coeff 8], Coeff 10]" (* same result *);
(*\------- foldr_dense_raw goes only 1 round over [Coeff 0, Coeff 2], unlike ML_Recursive_dense-/*)
*} ML {*
"~~~~~ fun foldr_dense_raw (*2*), args:"; val ((A1_, A2_), f, n, (*x :: xs*) xxx, b) = 
  ((A1_, A2_), x, Zero_nat, (rep_nat_mapping_dense A1_ xc), z);
(*!*)"~~mf0mf1~ fun (fn a => ..., args:"; val (_, a, p) = (n, nth xxx 1(*!!!!!!!!!!!!!!!!!!*), b);
*} ML {*
n = Zero_nat; (*                       ^^^_^^^ !?!?!?!?!?!?!?!?!??!?!?!?!?!?!?!?!?!?!?!?!?!?*)
lev = Suc Zero_nat;                         (* level of recursion in int poly_rec *)
a = Coeff (Pos (Bit0 One));                 (* nth ps = 1, right most list element, = Coeff 2 *)
p = Coeff Zero_int;                         (* init 2nd arg of foldr, = Coeff 0 *)
v;                                          (* the multiplicand*)
*} ML {*
if times (A1_'', A2_'', A3_'') (Suc lev) a (Powers v) 
  = (*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< mf0mf1 , times <<<<<<<<<<<*)
  Powers (Dense (Abs_nat_mapping_dense [
    Powers (Dense (Abs_nat_mapping_dense [Coeff Zero_int, Coeff (Pos (Bit0 (Bit0 (Bit0 One))))])), 
    Coeff (Pos (Bit0 (Bit1 (Bit0 One))))]))
(*= Powers [Powers [Coeff 0, Coeff 8], Coeff 10] OK *)
then () else error "(2.x + 3.y).(4.x + 5.y): mf0mf1 , times changed OK";
if inc_power_rec (zero_monoid_add A1_'', A3_'')
    (implT (zero_poly_rec (zero_monoid_add A1_'')) ps) lev p 
  = (*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< mf0mf1 , inc_power_rec <<<*)
  Coeff Zero_int
then () else error "times (2.x + 3.y).(4.x + 5.y): mf0mf1 inc_power_rec changed OK";
*} ML {*
val mf0mf1_result = f n a p;                         (* keep for further foldr OK *)
(*... = Powers [Powers [Coeff 0, Coeff 8], Coeff 10] OK *)
*} ML {*
(*!*)"~~mf0mf0~ fun (fn a => ..., args:"; val (_, a, p) = (n, nth xxx 0(*!!!!!!!*), mf0mf1_result);
*} ML {*
n = Zero_nat; (*                       ^^^_^^^ !?!?!?!?!?!?!?!?!??!?!?!?!?!?!?!?!?!?!?!?!?!?*)
lev = Suc Zero_nat;                         (* level of recursion in int poly_rec *)
a = Coeff Zero_int;                         (* = nth ps 0, next and last list element *)
p;                                          (* the intermediate result of foldr *)
                                               (*= Powers [Powers [Coeff 0, Coeff 8], Coeff 10] *)
v;                                          (* the multiplicand *)
*} ML {*
if times (A1_'', A2_'', A3_'') (Suc lev) a (Powers v)
  = (*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< mf0mf0 , times <<<<<<<<<<<*)
  Powers (Dense (Abs_nat_mapping_dense [])) (* shouldn't this be Coeff 0 ??? *)
then () else error "(2.x + 3.y).(4.x + 5.y): mf0mf0 , times changed";
if inc_power_rec (zero_monoid_add A1_'', A3_'')
    (implT (zero_poly_rec (zero_monoid_add A1_'')) ps) lev p 
  = (*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< mf0mf0 , inc_power_rec <<<*)
  Powers (Dense (Abs_nat_mapping_dense [
    Powers (Dense (Abs_nat_mapping_dense [
      Coeff Zero_int, Coeff Zero_int, Coeff (Pos (Bit0 (Bit0 (Bit0 One))))])),
   Powers (Dense (Abs_nat_mapping_dense [
    Coeff Zero_int, Coeff (Pos (Bit0 (Bit1 (Bit0 One))))]))]))
(*Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 10]] OK*)
then () else error "(2.x + 3.y).(4.x + 5.y): mf0mf0 , inc_power_rec changed";
*} ML {*
(*!*)val mf0mf0_result = f n a p;                (* keep for return at level 0: *)
(*Powers (Dense (Abs_nat_mapping_dense [
    Powers (Dense (Abs_nat_mapping_dense [
      Coeff Zero_int, Coeff Zero_int, Coeff (Pos (Bit0 (Bit0 (Bit0 One))))])),
    Powers (Dense (Abs_nat_mapping_dense [
      Coeff Zero_int, Coeff (Pos (Bit0 (Bit1 (Bit0 One))))]))]))
= Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 10]] OK *)
*} ML {*
"~~mf~~~~~ fun foldr, return:";
(*!*)if plus_poly_reca (A1_'', A3_'') mf0mf0_result mf0_inc 
(*!*)  = 
(*!*)  Powers (Dense (Abs_nat_mapping_dense [
(*!*)    Powers (Dense (Abs_nat_mapping_dense [
(*!*)      Coeff Zero_int, Coeff Zero_int, Coeff (Pos (Bit0 (Bit0 (Bit0 One))))])),
(*!*)    Powers (Dense (Abs_nat_mapping_dense [
(*!*)      Coeff Zero_int, 
(*!*)      Coeff (Pos (Bit0 (Bit1 (Bit1 (Bit0 One)))))])), 
(*!*)    Coeff (Pos (Bit1 (Bit1 (Bit1 One))))]))
(*!...\<doteq> Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 22], Coeff 15]
  !...RESULT OF foldr MIMICED EXPLICITLY BY HAND: ########################################### OK *)
then () else error "(2.x + 3.y).(4.x + 5.y) changed OK";
*} ML {*
(* how does generated code achieve such general signatures ? *)
foldr_dense_raw 
            : 'a zero * 'a equal -> (nat -> 'a -> 'b -> 'b) -> nat -> 'a list           -> 'b -> 'b;
foldr_dense : 'a zero * 'a equal -> (nat -> 'a -> 'b -> 'b) ->     'a nat_mapping_dense -> 'b -> 'b;
foldra      : 'a zero * 'a equal -> (nat -> 'a -> 'b -> 'b) ->     'a nat_mapping       -> 'b -> 'b;
(*fun foldr_dense_raw (*1*) (A1_, A2_) f n [] b = b
  | foldr_dense_raw (*2*) (A1_, A2_) f n (x :: xs) b =
    (if eq A2_ x (zero A1_) then id else f n x) (foldr_dense_raw (A1_, A2_) f (Suc n) xs b);
        ^^^^^^^^^^^^^^^^^^^
THIS WAY^^^                
We would have to use the code generator's dictionary mechanism to achieve similar generality *)
*}
subsubsection {* Mult. foldr_step gen.code from poly f482e1c2f6ec *}
definition p0002003 :: "int mpoly" --{* recursive dense *}
where "p0002003 = 
  monom' (REC (\<lambda>_. DENSE)) (Nat_Mapping.single' DENSE 0 3) 2 +
  monom' (REC (\<lambda>_. DENSE)) (Nat_Mapping.single' DENSE 0 6) 3  "
definition p1002003 :: "int mpoly" --{* recursive dense *}
where "p1002003 = 
  monom' (REC (\<lambda>_. DENSE)) (Nat_Mapping.single' DENSE 0 0) 1 +
  monom' (REC (\<lambda>_. DENSE)) (Nat_Mapping.single' DENSE 0 3) 2 +
  monom' (REC (\<lambda>_. DENSE)) (Nat_Mapping.single' DENSE 0 6) 3  "
definition p45 :: "int mpoly" --{* recursive dense *}
where "p45 = 
  monom' (REC (\<lambda>_. DENSE)) (Nat_Mapping.single' DENSE 0 0) 4 +
  monom' (REC (\<lambda>_. DENSE)) (Nat_Mapping.single' DENSE 0 1) 5  "
value "p0002003 * p45" --{* with times..funpow (n'' - n):
= "Rec (Powers (Dense 
  [Coeff 0, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]))"
   ^^^^^^^^^^^^^^^^^^^^^^^^^ OK                         ///////// too much*}
value "p1002003 * p45" --{* with times..funpow (n'' - n):
= "Rec (Powers (Dense 
  [Coeff 4, Coeff 5, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]))"
                             ///////// too much                   ///////// too much*}
(*TODO*)value "p002003 * p45" --{* with times..funpow (n'' - n - 1):
= "Rec (Powers (Dense [Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 12, Coeff 15]))"
                            Coeff 0, missing             //// OK*}
value "p2x3y * p4x5y" --{* with times..funpow (n'' - n):
= "Rec (Powers (Dense [
    Powers (Dense [Coeff 0, Coeff 0, Coeff 8]),    ..OK
    Powers (Dense [Coeff 0, Coeff 10]),            ....... + 
    Powers (Dense [Coeff 0, Coeff 12]),            ....... +  OK: [Coeff 0, Coeff 22]
    Coeff 15]))"                                   ..OK*}
value "p2x3y * p4x5y" --{* with times..funpow (n'' - n - 1):
= "Rec (Powers (Dense [
    Powers (Dense [Coeff 0, Coeff 8]),             ..Not ok: [Coeff 0, Coeff 0, Coeff 8]
    Powers (Dense [Coeff 10, Coeff 12]),           ..Not ok: [Coeff 0, Coeff 22]
    Coeff 15]))"                                   ..OK
*}
export_code try_times p2x3y p4x5y p0002003 p1002003 p45 in SML module_name Try_Times 
ML {* (* from poly f482e1c2f6ec *)
*} ML {*
(*
structure Try_Times : sig
  type num
  type int
  type nat
  type 'a nat_mapping
  type implb
  type 'a mpoly
  type impl
  val p45 : int mpoly
  val p2x3y : int mpoly
  val p4x5y : int mpoly
  val p002003 : int mpoly
  val try_times : int mpoly -> int mpoly -> int mpoly
end = struct
*)
type 'a uminus = {uminus : 'a -> 'a};
val uminus = #uminus : 'a uminus -> 'a -> 'a;

fun uminus_funa B_ a x = uminus B_ (a x);

fun uminus_fun B_ = {uminus = uminus_funa B_} : ('a -> 'b) uminus;

datatype num = One | Bit0 of num | Bit1 of num;

fun equal_num (Bit0 numa) (Bit1 num) = false
  | equal_num (Bit1 numa) (Bit0 num) = false
  | equal_num One (Bit1 num) = false
  | equal_num (Bit1 num) One = false
  | equal_num One (Bit0 num) = false
  | equal_num (Bit0 num) One = false
  | equal_num (Bit1 numa) (Bit1 num) = equal_num numa num
  | equal_num (Bit0 numa) (Bit0 num) = equal_num numa num
  | equal_num One One = true;

datatype int = Zero_int | Pos of num | Neg of num;

fun equal_inta (Neg k) (Neg l) = equal_num k l
  | equal_inta (Neg k) (Pos l) = false
  | equal_inta (Neg k) Zero_int = false
  | equal_inta (Pos k) (Neg l) = false
  | equal_inta (Pos k) (Pos l) = equal_num k l
  | equal_inta (Pos k) Zero_int = false
  | equal_inta Zero_int (Neg l) = false
  | equal_inta Zero_int (Pos l) = false
  | equal_inta Zero_int Zero_int = true;

type 'a equal = {equal : 'a -> 'a -> bool};
val equal = #equal : 'a equal -> 'a -> 'a -> bool;

val equal_int = {equal = equal_inta} : int equal;

val one_inta : int = Pos One;

type 'a one = {one : 'a};
val one = #one : 'a one -> 'a;

val one_int = {one = one_inta} : int one;

fun uminus_inta (Neg m) = Pos m
  | uminus_inta (Pos m) = Neg m
  | uminus_inta Zero_int = Zero_int;

fun plus_num (Bit1 m) (Bit1 n) = Bit0 (plus_num (plus_num m n) One)
  | plus_num (Bit1 m) (Bit0 n) = Bit1 (plus_num m n)
  | plus_num (Bit1 m) One = Bit0 (plus_num m One)
  | plus_num (Bit0 m) (Bit1 n) = Bit1 (plus_num m n)
  | plus_num (Bit0 m) (Bit0 n) = Bit0 (plus_num m n)
  | plus_num (Bit0 m) One = Bit1 m
  | plus_num One (Bit1 n) = Bit0 (plus_num n One)
  | plus_num One (Bit0 n) = Bit1 n
  | plus_num One One = Bit0 One;

fun times_num (Bit1 m) (Bit1 n) =
  Bit1 (plus_num (plus_num m n) (Bit0 (times_num m n)))
  | times_num (Bit1 m) (Bit0 n) = Bit0 (times_num (Bit1 m) n)
  | times_num (Bit0 m) (Bit1 n) = Bit0 (times_num m (Bit1 n))
  | times_num (Bit0 m) (Bit0 n) = Bit0 (Bit0 (times_num m n))
  | times_num One n = n
  | times_num m One = m;

fun times_inta (Neg m) (Neg n) = Pos (times_num m n)
  | times_inta (Neg m) (Pos n) = Neg (times_num m n)
  | times_inta (Pos m) (Neg n) = Neg (times_num m n)
  | times_inta (Pos m) (Pos n) = Pos (times_num m n)
  | times_inta Zero_int l = Zero_int
  | times_inta k Zero_int = Zero_int;

fun bitM One = One
  | bitM (Bit0 n) = Bit1 (bitM n)
  | bitM (Bit1 n) = Bit1 (Bit0 n);

fun dup (Neg n) = Neg (Bit0 n)
  | dup (Pos n) = Pos (Bit0 n)
  | dup Zero_int = Zero_int;

fun minus_inta (Neg m) (Neg n) = sub n m
  | minus_inta (Neg m) (Pos n) = Neg (plus_num m n)
  | minus_inta (Pos m) (Neg n) = Pos (plus_num m n)
  | minus_inta (Pos m) (Pos n) = sub m n
  | minus_inta Zero_int l = uminus_inta l
  | minus_inta k Zero_int = k
and sub (Bit0 m) (Bit1 n) = minus_inta (dup (sub m n)) (Pos One)
  | sub (Bit1 m) (Bit0 n) = plus_inta (dup (sub m n)) (Pos One)
  | sub (Bit1 m) (Bit1 n) = dup (sub m n)
  | sub (Bit0 m) (Bit0 n) = dup (sub m n)
  | sub One (Bit1 n) = Neg (Bit0 n)
  | sub One (Bit0 n) = Neg (bitM n)
  | sub (Bit1 m) One = Pos (Bit0 m)
  | sub (Bit0 m) One = Pos (bitM m)
  | sub One One = Zero_int
and plus_inta (Neg m) (Neg n) = Neg (plus_num m n)
  | plus_inta (Neg m) (Pos n) = sub n m
  | plus_inta (Pos m) (Neg n) = sub m n
  | plus_inta (Pos m) (Pos n) = Pos (plus_num m n)
  | plus_inta Zero_int l = l
  | plus_inta k Zero_int = k;

type 'a times = {timesa : 'a -> 'a -> 'a};
val timesa = #timesa : 'a times -> 'a -> 'a -> 'a;

type 'a minus = {minus : 'a -> 'a -> 'a};
val minus = #minus : 'a minus -> 'a -> 'a -> 'a;

type 'a zero = {zero : 'a};
val zero = #zero : 'a zero -> 'a;

type 'a plus = {plus : 'a -> 'a -> 'a};
val plus = #plus : 'a plus -> 'a -> 'a -> 'a;

type 'a semigroup_add = {plus_semigroup_add : 'a plus};
val plus_semigroup_add = #plus_semigroup_add : 'a semigroup_add -> 'a plus;

type 'a cancel_semigroup_add =
  {semigroup_add_cancel_semigroup_add : 'a semigroup_add};
val semigroup_add_cancel_semigroup_add = #semigroup_add_cancel_semigroup_add :
  'a cancel_semigroup_add -> 'a semigroup_add;

type 'a ab_semigroup_add = {semigroup_add_ab_semigroup_add : 'a semigroup_add};
val semigroup_add_ab_semigroup_add = #semigroup_add_ab_semigroup_add :
  'a ab_semigroup_add -> 'a semigroup_add;

type 'a cancel_ab_semigroup_add =
  {ab_semigroup_add_cancel_ab_semigroup_add : 'a ab_semigroup_add,
    cancel_semigroup_add_cancel_ab_semigroup_add : 'a cancel_semigroup_add};
val ab_semigroup_add_cancel_ab_semigroup_add =
  #ab_semigroup_add_cancel_ab_semigroup_add :
  'a cancel_ab_semigroup_add -> 'a ab_semigroup_add;
val cancel_semigroup_add_cancel_ab_semigroup_add =
  #cancel_semigroup_add_cancel_ab_semigroup_add :
  'a cancel_ab_semigroup_add -> 'a cancel_semigroup_add;

type 'a monoid_add =
  {semigroup_add_monoid_add : 'a semigroup_add, zero_monoid_add : 'a zero};
val semigroup_add_monoid_add = #semigroup_add_monoid_add :
  'a monoid_add -> 'a semigroup_add;
val zero_monoid_add = #zero_monoid_add : 'a monoid_add -> 'a zero;

type 'a comm_monoid_add =
  {ab_semigroup_add_comm_monoid_add : 'a ab_semigroup_add,
    monoid_add_comm_monoid_add : 'a monoid_add};
val ab_semigroup_add_comm_monoid_add = #ab_semigroup_add_comm_monoid_add :
  'a comm_monoid_add -> 'a ab_semigroup_add;
val monoid_add_comm_monoid_add = #monoid_add_comm_monoid_add :
  'a comm_monoid_add -> 'a monoid_add;

type 'a cancel_comm_monoid_add =
  {cancel_ab_semigroup_add_cancel_comm_monoid_add : 'a cancel_ab_semigroup_add,
    comm_monoid_add_cancel_comm_monoid_add : 'a comm_monoid_add};
val cancel_ab_semigroup_add_cancel_comm_monoid_add =
  #cancel_ab_semigroup_add_cancel_comm_monoid_add :
  'a cancel_comm_monoid_add -> 'a cancel_ab_semigroup_add;
val comm_monoid_add_cancel_comm_monoid_add =
  #comm_monoid_add_cancel_comm_monoid_add :
  'a cancel_comm_monoid_add -> 'a comm_monoid_add;

type 'a mult_zero = {times_mult_zero : 'a times, zero_mult_zero : 'a zero};
val times_mult_zero = #times_mult_zero : 'a mult_zero -> 'a times;
val zero_mult_zero = #zero_mult_zero : 'a mult_zero -> 'a zero;

type 'a semigroup_mult = {times_semigroup_mult : 'a times};
val times_semigroup_mult = #times_semigroup_mult :
  'a semigroup_mult -> 'a times;

type 'a semiring =
  {ab_semigroup_add_semiring : 'a ab_semigroup_add,
    semigroup_mult_semiring : 'a semigroup_mult};
val ab_semigroup_add_semiring = #ab_semigroup_add_semiring :
  'a semiring -> 'a ab_semigroup_add;
val semigroup_mult_semiring = #semigroup_mult_semiring :
  'a semiring -> 'a semigroup_mult;

type 'a semiring_0 =
  {comm_monoid_add_semiring_0 : 'a comm_monoid_add,
    mult_zero_semiring_0 : 'a mult_zero, semiring_semiring_0 : 'a semiring};
val comm_monoid_add_semiring_0 = #comm_monoid_add_semiring_0 :
  'a semiring_0 -> 'a comm_monoid_add;
val mult_zero_semiring_0 = #mult_zero_semiring_0 :
  'a semiring_0 -> 'a mult_zero;
val semiring_semiring_0 = #semiring_semiring_0 : 'a semiring_0 -> 'a semiring;

type 'a semiring_0_cancel =
  {cancel_comm_monoid_add_semiring_0_cancel : 'a cancel_comm_monoid_add,
    semiring_0_semiring_0_cancel : 'a semiring_0};
val cancel_comm_monoid_add_semiring_0_cancel =
  #cancel_comm_monoid_add_semiring_0_cancel :
  'a semiring_0_cancel -> 'a cancel_comm_monoid_add;
val semiring_0_semiring_0_cancel = #semiring_0_semiring_0_cancel :
  'a semiring_0_cancel -> 'a semiring_0;

type 'a group_add =
  {cancel_semigroup_add_group_add : 'a cancel_semigroup_add,
    minus_group_add : 'a minus, monoid_add_group_add : 'a monoid_add,
    uminus_group_add : 'a uminus};
val cancel_semigroup_add_group_add = #cancel_semigroup_add_group_add :
  'a group_add -> 'a cancel_semigroup_add;
val minus_group_add = #minus_group_add : 'a group_add -> 'a minus;
val monoid_add_group_add = #monoid_add_group_add :
  'a group_add -> 'a monoid_add;
val uminus_group_add = #uminus_group_add : 'a group_add -> 'a uminus;

type 'a ab_group_add =
  {cancel_comm_monoid_add_ab_group_add : 'a cancel_comm_monoid_add,
    group_add_ab_group_add : 'a group_add};
val cancel_comm_monoid_add_ab_group_add = #cancel_comm_monoid_add_ab_group_add :
  'a ab_group_add -> 'a cancel_comm_monoid_add;
val group_add_ab_group_add = #group_add_ab_group_add :
  'a ab_group_add -> 'a group_add;

type 'a ring =
  {ab_group_add_ring : 'a ab_group_add,
    semiring_0_cancel_ring : 'a semiring_0_cancel};
val ab_group_add_ring = #ab_group_add_ring : 'a ring -> 'a ab_group_add;
val semiring_0_cancel_ring = #semiring_0_cancel_ring :
  'a ring -> 'a semiring_0_cancel;

val plus_int = {plus = plus_inta} : int plus;

val semigroup_add_int = {plus_semigroup_add = plus_int} : int semigroup_add;

val cancel_semigroup_add_int =
  {semigroup_add_cancel_semigroup_add = semigroup_add_int} :
  int cancel_semigroup_add;

val ab_semigroup_add_int = {semigroup_add_ab_semigroup_add = semigroup_add_int}
  : int ab_semigroup_add;

val cancel_ab_semigroup_add_int =
  {ab_semigroup_add_cancel_ab_semigroup_add = ab_semigroup_add_int,
    cancel_semigroup_add_cancel_ab_semigroup_add = cancel_semigroup_add_int}
  : int cancel_ab_semigroup_add;

val zero_int = {zero = Zero_int} : int zero;

val monoid_add_int =
  {semigroup_add_monoid_add = semigroup_add_int, zero_monoid_add = zero_int} :
  int monoid_add;

val comm_monoid_add_int =
  {ab_semigroup_add_comm_monoid_add = ab_semigroup_add_int,
    monoid_add_comm_monoid_add = monoid_add_int}
  : int comm_monoid_add;

val cancel_comm_monoid_add_int =
  {cancel_ab_semigroup_add_cancel_comm_monoid_add = cancel_ab_semigroup_add_int,
    comm_monoid_add_cancel_comm_monoid_add = comm_monoid_add_int}
  : int cancel_comm_monoid_add;

val times_int = {timesa = times_inta} : int times;

val mult_zero_int = {times_mult_zero = times_int, zero_mult_zero = zero_int} :
  int mult_zero;

val semigroup_mult_int = {times_semigroup_mult = times_int} :
  int semigroup_mult;

val semiring_int =
  {ab_semigroup_add_semiring = ab_semigroup_add_int,
    semigroup_mult_semiring = semigroup_mult_int}
  : int semiring;

val semiring_0_int =
  {comm_monoid_add_semiring_0 = comm_monoid_add_int,
    mult_zero_semiring_0 = mult_zero_int, semiring_semiring_0 = semiring_int}
  : int semiring_0;

val semiring_0_cancel_int =
  {cancel_comm_monoid_add_semiring_0_cancel = cancel_comm_monoid_add_int,
    semiring_0_semiring_0_cancel = semiring_0_int}
  : int semiring_0_cancel;

val uminus_int = {uminus = uminus_inta} : int uminus;

val minus_int = {minus = minus_inta} : int minus;

val group_add_int =
  {cancel_semigroup_add_group_add = cancel_semigroup_add_int,
    minus_group_add = minus_int, monoid_add_group_add = monoid_add_int,
    uminus_group_add = uminus_int}
  : int group_add;

val ab_group_add_int =
  {cancel_comm_monoid_add_ab_group_add = cancel_comm_monoid_add_int,
    group_add_ab_group_add = group_add_int}
  : int ab_group_add;

val ring_int =
  {ab_group_add_ring = ab_group_add_int,
    semiring_0_cancel_ring = semiring_0_cancel_int}
  : int ring;

datatype nat = Zero_nat | Suc of nat;

fun equal_nata Zero_nat (Suc x2) = false
  | equal_nata (Suc x2) Zero_nat = false
  | equal_nata (Suc x2) (Suc y2) = equal_nata x2 y2
  | equal_nata Zero_nat Zero_nat = true;

val equal_nat = {equal = equal_nata} : nat equal;

val zero_nat = {zero = Zero_nat} : nat zero;

fun less_eq_nat (Suc m) n = less_nat m n
  | less_eq_nat Zero_nat n = true
and less_nat m (Suc n) = less_eq_nat m n
  | less_nat n Zero_nat = false;

type 'a ord = {less_eq : 'a -> 'a -> bool, less : 'a -> 'a -> bool};
val less_eq = #less_eq : 'a ord -> 'a -> 'a -> bool;
val less = #less : 'a ord -> 'a -> 'a -> bool;

val ord_nat = {less_eq = less_eq_nat, less = less_nat} : nat ord;

type 'a preorder = {ord_preorder : 'a ord};
val ord_preorder = #ord_preorder : 'a preorder -> 'a ord;

type 'a order = {preorder_order : 'a preorder};
val preorder_order = #preorder_order : 'a order -> 'a preorder;

val preorder_nat = {ord_preorder = ord_nat} : nat preorder;

val order_nat = {preorder_order = preorder_nat} : nat order;

type 'a linpreorder = {preorder_linpreorder : 'a preorder};
val preorder_linpreorder = #preorder_linpreorder :
  'a linpreorder -> 'a preorder;

type 'a linorder =
  {linpreorder_linorder : 'a linpreorder, order_linorder : 'a order};
val linpreorder_linorder = #linpreorder_linorder :
  'a linorder -> 'a linpreorder;
val order_linorder = #order_linorder : 'a linorder -> 'a order;

val linpreorder_nat = {preorder_linpreorder = preorder_nat} : nat linpreorder;

val linorder_nat =
  {linpreorder_linorder = linpreorder_nat, order_linorder = order_nat} :
  nat linorder;

fun compare_nat (Suc n) (Suc m) = compare_nat n m
  | compare_nat (Suc n) Zero_nat = General.GREATER
  | compare_nat Zero_nat (Suc m) = General.LESS
  | compare_nat Zero_nat Zero_nat = General.EQUAL;

type 'a linpreorder_compare =
  {linpreorder_linpreorder_compare : 'a linpreorder,
    compare : 'a -> 'a -> General.order};
val linpreorder_linpreorder_compare = #linpreorder_linpreorder_compare :
  'a linpreorder_compare -> 'a linpreorder;
val compare = #compare : 'a linpreorder_compare -> 'a -> 'a -> General.order;

type 'a linorder_compare =
  {linpreorder_compare_linorder_compare : 'a linpreorder_compare,
    linorder_linorder_compare : 'a linorder};
val linpreorder_compare_linorder_compare = #linpreorder_compare_linorder_compare
  : 'a linorder_compare -> 'a linpreorder_compare;
val linorder_linorder_compare = #linorder_linorder_compare :
  'a linorder_compare -> 'a linorder;

val linpreorder_compare_nat =
  {linpreorder_linpreorder_compare = linpreorder_nat, compare = compare_nat} :
  nat linpreorder_compare;

val linorder_compare_nat =
  {linpreorder_compare_linorder_compare = linpreorder_compare_nat,
    linorder_linorder_compare = linorder_nat}
  : nat linorder_compare;

fun eq A_ a b = equal A_ a b;

fun equal_proda A_ B_ (x1, x2) (y1, y2) = eq A_ x1 y1 andalso eq B_ x2 y2;

fun equal_prod A_ B_ = {equal = equal_proda A_ B_} : ('a * 'b) equal;

fun less_eq_prod A_ B_ (x1, y1) (x2, y2) =
  less A_ x1 x2 orelse less_eq A_ x1 x2 andalso less_eq B_ y1 y2;

fun less_prod A_ B_ (x1, y1) (x2, y2) =
  less A_ x1 x2 orelse less_eq A_ x1 x2 andalso less B_ y1 y2;

fun ord_prod A_ B_ = {less_eq = less_eq_prod A_ B_, less = less_prod A_ B_} :
  ('a * 'b) ord;

fun preorder_prod A_ B_ =
  {ord_preorder = ord_prod (ord_preorder A_) (ord_preorder B_)} :
  ('a * 'b) preorder;

fun order_prod A_ B_ =
  {preorder_order = preorder_prod (preorder_order A_) (preorder_order B_)} :
  ('a * 'b) order;

fun uminus_comparisona General.LESS = General.GREATER
  | uminus_comparisona General.EQUAL = General.EQUAL
  | uminus_comparisona General.GREATER = General.LESS;

val uminus_comparison = {uminus = uminus_comparisona} : General.order uminus;

fun less_eq_list (A1_, A2_) (x :: xs) (y :: ys) =
  less ((ord_preorder o preorder_order) A2_) x y orelse
    eq A1_ x y andalso less_eq_list (A1_, A2_) xs ys
  | less_eq_list (A1_, A2_) [] xs = true
  | less_eq_list (A1_, A2_) (x :: xs) [] = false;

datatype 'a nat_mapping_sparse = Abs_nat_mapping_sparse of (nat * 'a) list;

fun rep_nat_mapping_sparse A_ (Abs_nat_mapping_sparse x) = x;

fun less_eq_nat_mapping_sparse (A1_, A2_, A3_) xa xc =
  less_eq_list
    (equal_prod equal_nat A2_, order_prod order_nat (order_linorder A3_))
    (rep_nat_mapping_sparse A1_ xa) (rep_nat_mapping_sparse A1_ xc);

datatype 'a nat_mapping_dense = Abs_nat_mapping_dense of 'a list;

fun rep_nat_mapping_dense A_ (Abs_nat_mapping_dense x) = x;

fun less_eq_nat_mapping_dense (A1_, A2_, A3_) xa xc =
  less_eq_list (A2_, order_linorder A3_) (rep_nat_mapping_dense A1_ xa)
    (rep_nat_mapping_dense A1_ xc);

datatype nibble = Nibble0 | Nibble1 | Nibble2 | Nibble3 | Nibble4 | Nibble5 |
  Nibble6 | Nibble7 | Nibble8 | Nibble9 | NibbleA | NibbleB | NibbleC | NibbleD
  | NibbleE | NibbleF;

datatype 'a nat_mapping = Dense of 'a nat_mapping_dense |
  Sparse of 'a nat_mapping_sparse;

datatype char = Char of nibble * nibble;

fun less_eq_nat_mapping (A1_, A2_, A3_) (Sparse x) (Sparse y) =
  less_eq_nat_mapping_sparse (A1_, A2_, A3_) x y
  | less_eq_nat_mapping (A1_, A2_, A3_) (Dense x) (Dense y) =
    less_eq_nat_mapping_dense (A1_, A2_, A3_) x y
  | less_eq_nat_mapping (A1_, A2_, A3_) x y =
    (raise Fail
      "order comparison between different representations unsupported")
      (fn _ => less_eq_nat_mapping (A1_, A2_, A3_) x y);

fun less_list (A1_, A2_) (x :: xs) (y :: ys) =
  less ((ord_preorder o preorder_order) A2_) x y orelse
    eq A1_ x y andalso less_list (A1_, A2_) xs ys
  | less_list (A1_, A2_) [] (x :: xs) = true
  | less_list (A1_, A2_) xs [] = false;

fun less_nat_mapping_sparse (A1_, A2_, A3_) xa xc =
  less_list
    (equal_prod equal_nat A2_, order_prod order_nat (order_linorder A3_))
    (rep_nat_mapping_sparse A1_ xa) (rep_nat_mapping_sparse A1_ xc);

fun less_nat_mapping_dense (A1_, A2_, A3_) xa xc =
  less_list (A2_, order_linorder A3_) (rep_nat_mapping_dense A1_ xa)
    (rep_nat_mapping_dense A1_ xc);

fun less_nat_mapping (A1_, A2_, A3_) (Sparse x) (Sparse y) =
  less_nat_mapping_sparse (A1_, A2_, A3_) x y
  | less_nat_mapping (A1_, A2_, A3_) (Dense x) (Dense y) =
    less_nat_mapping_dense (A1_, A2_, A3_) x y
  | less_nat_mapping (A1_, A2_, A3_) x y =
    (raise Fail
      "strict order comparison between different representations unsupported")
      (fn _ => less_nat_mapping (A1_, A2_, A3_) x y);

fun ord_nat_mapping (A1_, A2_, A3_) =
  {less_eq = less_eq_nat_mapping (A1_, A2_, A3_),
    less = less_nat_mapping (A1_, A2_, A3_)}
  : 'a nat_mapping ord;

fun equal_list A_ [] (x21 :: x22) = false
  | equal_list A_ (x21 :: x22) [] = false
  | equal_list A_ (x21 :: x22) (y21 :: y22) =
    eq A_ x21 y21 andalso equal_list A_ x22 y22
  | equal_list A_ [] [] = true;

fun equal_nat_mapping_sparse (A1_, A2_) xa xc =
  equal_list (equal_prod equal_nat A2_) (rep_nat_mapping_sparse A1_ xa)
    (rep_nat_mapping_sparse A1_ xc);

fun equal_nat_mapping_dense (A1_, A2_) xa xc =
  equal_list A2_ (rep_nat_mapping_dense A1_ xa) (rep_nat_mapping_dense A1_ xc);

fun equal_nat_mapping (A1_, A2_) (Sparse x) (Sparse y) =
  equal_nat_mapping_sparse (A1_, A2_) x y
  | equal_nat_mapping (A1_, A2_) (Dense x) (Dense y) =
    equal_nat_mapping_dense (A1_, A2_) x y
  | equal_nat_mapping (A1_, A2_) x y =
    (raise Fail
      "equality comparison between different representations unsupported")
      (fn _ => equal_nat_mapping (A1_, A2_) x y);

datatype 'a poly_rec = Coeff of 'a | Powers of 'a poly_rec nat_mapping;

fun zero_poly_reca A_ = Coeff (zero A_);

fun zero_poly_rec A_ = {zero = zero_poly_reca A_} : 'a poly_rec zero;

fun equal_poly_rec (A1_, A2_) = {equal = equal_poly_reca (A1_, A2_)} :
  'a poly_rec equal
and equal_poly_reca (A1_, A2_) (Coeff x1) (Powers x2) = false
  | equal_poly_reca (A1_, A2_) (Powers x2) (Coeff x1) = false
  | equal_poly_reca (A1_, A2_) (Powers x2) (Powers y2) =
    equal_nat_mapping (zero_poly_rec A1_, equal_poly_rec (A1_, A2_)) x2 y2
  | equal_poly_reca (A1_, A2_) (Coeff x1) (Coeff y1) = eq A2_ x1 y1;

fun comparator_of_le A_ x y =
  (if less_eq A_ x y
    then (if less_eq A_ y x then General.EQUAL else General.LESS)
    else General.GREATER);

fun filter_map2 f ((k, v) :: xs) =
  (case f k v of NONE => filter_map2 f xs
    | SOME w => (k, w) :: filter_map2 f xs)
  | filter_map2 f [] = [];

fun oa_zip_with cmp f g h ((ka, va) :: xs) ((k, v) :: ys) =
  (case cmp ka k
    of General.LESS =>
      (case f ka va of NONE => oa_zip_with cmp f g h xs ((k, v) :: ys)
        | SOME w => (ka, w) :: oa_zip_with cmp f g h xs ((k, v) :: ys))
    | General.EQUAL =>
      (case h ka va v of NONE => oa_zip_with cmp f g h xs ys
        | SOME w => (ka, w) :: oa_zip_with cmp f g h xs ys)
    | General.GREATER =>
      (case g k v of NONE => oa_zip_with cmp f g h ((ka, va) :: xs) ys
        | SOME w => (k, w) :: oa_zip_with cmp f g h ((ka, va) :: xs) ys))
  | oa_zip_with cmp f g h xs [] = filter_map2 f xs
  | oa_zip_with cmp f g h [] ys = filter_map2 g ys;

fun zip_with_sparse_raw A_ B_ C_ (D1_, D2_) f xs ys =
  oa_zip_with
    (comparator_of_le ((ord_preorder o preorder_order o order_linorder) A_))
    (fn k => fn v =>
      let
        val z = f k v (zero C_);
      in
        (if eq D2_ z (zero D1_) then NONE else SOME z)
      end)
    (fn k => fn v =>
      let
        val z = f k (zero B_) v;
      in
        (if eq D2_ z (zero D1_) then NONE else SOME z)
      end)
    (fn k => fn v => fn va =>
      let
        val z = f k v va;
      in
        (if eq D2_ z (zero D1_) then NONE else SOME z)
      end)
    xs ys;

fun zip_with_sparse B_ C_ (A1_, A2_) xc xd xe =
  Abs_nat_mapping_sparse
    (zip_with_sparse_raw linorder_nat B_ C_ (A1_, A2_) xc
      (rep_nat_mapping_sparse B_ xd) (rep_nat_mapping_sparse C_ xe));

fun apply0 (A1_, A2_) B_ f x = (if eq A2_ x (zero A1_) then zero B_ else f x);

fun null [] = true
  | null (x :: xs) = false;

fun strip_map (A1_, A2_) (B1_, B2_) f n [] = []
  | strip_map (A1_, A2_) (B1_, B2_) f n (x :: xs) =
    let
      val ys = strip_map (A1_, A2_) (B1_, B2_) f (Suc n) xs;
      val y = apply0 (A1_, A2_) B1_ (f n) x;
    in
      (if null ys andalso eq B2_ y (zero B1_) then [] else y :: ys)
    end;

fun apply0_2 (A1_, A2_) (B1_, B2_) C_ f x y =
  (if eq A2_ x (zero A1_) andalso eq B2_ y (zero B1_) then zero C_ else f x y);

fun zip_with_dense_raw (A1_, A2_) (B1_, B2_) (C1_, C2_) f n [] ys =
  strip_map (B1_, B2_) (C1_, C2_) (fn na => f na (zero A1_)) n ys
  | zip_with_dense_raw (A1_, A2_) (B1_, B2_) (C1_, C2_) f n xs [] =
    strip_map (A1_, A2_) (C1_, C2_) (fn na => fn x => f na x (zero B1_)) n xs
  | zip_with_dense_raw (A1_, A2_) (B1_, B2_) (C1_, C2_) f n (x :: xs) (y :: ys)
    = let
        val zs =
          zip_with_dense_raw (A1_, A2_) (B1_, B2_) (C1_, C2_) f (Suc n) xs ys;
        val z = apply0_2 (A1_, A2_) (B1_, B2_) C1_ (f n) x y;
      in
        (if null zs andalso eq C2_ z (zero C1_) then [] else z :: zs)
      end;

fun zip_with_dense (B1_, B2_) (C1_, C2_) (A1_, A2_) xc xd xe =
  Abs_nat_mapping_dense
    (zip_with_dense_raw (B1_, B2_) (C1_, C2_) (A1_, A2_) xc Zero_nat
      (rep_nat_mapping_dense B1_ xd) (rep_nat_mapping_dense C1_ xe));

fun plus_nat_mapping (A1_, A2_) (Sparse xs) (Sparse ys) =
  Sparse
    (zip_with_sparse (zero_monoid_add A1_) (zero_monoid_add A1_)
      (zero_monoid_add A1_, A2_)
      (fn _ => plus ((plus_semigroup_add o semigroup_add_monoid_add) A1_)) xs
      ys)
  | plus_nat_mapping (A1_, A2_) (Dense xs) (Dense ys) =
    Dense (zip_with_dense (zero_monoid_add A1_, A2_) (zero_monoid_add A1_, A2_)
            (zero_monoid_add A1_, A2_)
            (fn _ => plus ((plus_semigroup_add o semigroup_add_monoid_add) A1_))
            xs ys);

fun single_sparse (A1_, A2_) xb xc =
  Abs_nat_mapping_sparse (if eq A2_ xc (zero A1_) then [] else [(xb, xc)]);

fun replicate Zero_nat x = []
  | replicate (Suc n) x = x :: replicate n x;

fun single_dense (A1_, A2_) xb xc =
  Abs_nat_mapping_dense
    (if eq A2_ xc (zero A1_) then [] else replicate xb (zero A1_) @ [xc]);

datatype implb = DENSE | SPARSE;

fun single (A1_, A2_) SPARSE k v = Sparse (single_sparse (A1_, A2_) k v)
  | single (A1_, A2_) DENSE k v = Dense (single_dense (A1_, A2_) k v);

fun implT A_ (Sparse s) = SPARSE
  | implT A_ (Dense d) = DENSE;

fun plus_poly_rec (A1_, A2_) = {plus = plus_poly_reca (A1_, A2_)} :
  'a poly_rec plus
and semigroup_add_poly_rec (A1_, A2_) =
  {plus_semigroup_add = plus_poly_rec (A1_, A2_)} : 'a poly_rec semigroup_add
and monoid_add_poly_rec (A1_, A2_) =
  {semigroup_add_monoid_add = semigroup_add_poly_rec (A1_, A2_),
    zero_monoid_add = zero_poly_rec (zero_monoid_add A1_)}
  : 'a poly_rec monoid_add
and plus_poly_reca (A1_, A2_) (Powers ps) (Coeff y) =
  Powers
    (plus_nat_mapping
      (monoid_add_poly_rec (A1_, A2_),
        equal_poly_rec (zero_monoid_add A1_, A2_))
      ps (single
           (zero_poly_rec (zero_monoid_add A1_),
             equal_poly_rec (zero_monoid_add A1_, A2_))
           (implT (zero_poly_rec (zero_monoid_add A1_)) ps) Zero_nat (Coeff y)))
  | plus_poly_reca (A1_, A2_) (Coeff x) (Powers qs) =
    Powers
      (plus_nat_mapping
        (monoid_add_poly_rec (A1_, A2_),
          equal_poly_rec (zero_monoid_add A1_, A2_))
        (single
          (zero_poly_rec (zero_monoid_add A1_),
            equal_poly_rec (zero_monoid_add A1_, A2_))
          (implT (zero_poly_rec (zero_monoid_add A1_)) qs) Zero_nat (Coeff x))
        qs)
  | plus_poly_reca (A1_, A2_) (Powers ps) (Powers qs) =
    Powers
      (plus_nat_mapping
        (monoid_add_poly_rec (A1_, A2_),
          equal_poly_rec (zero_monoid_add A1_, A2_))
        ps qs)
  | plus_poly_reca (A1_, A2_) (Coeff x) (Coeff y) =
    Coeff (plus ((plus_semigroup_add o semigroup_add_monoid_add) A1_) x y);

datatype monom_order = Rlex_mo | Lex_mo;

datatype 'a poly_distr =
  Poly_distr_of_raw of ((nat nat_mapping * 'a) list * monom_order);

datatype 'a mpoly = Distr of 'a poly_distr | Rec of 'a poly_rec;

datatype impla = RLEX | LEX;

datatype impl = REC of (nat -> implb) | DISTR of impla;

datatype ('b, 'a) ignore_arg = Abs_ignore_arg of ('b -> 'a);

*} ML {*
(*/---------- prepare investigation of foldr ---------------------------------------------------\*)
fun dest_nat Zero_nat = 0
  | dest_nat (Suc n') = 1 + dest_nat n';
fun nat_str n = n |> dest_nat |> string_of_int |> curry op ^ "#";
fun nat_int n = n |> dest_nat;

if nat_str (Suc (Suc Zero_nat)) = "#2" then () else error "nat_str changed";
if nat_int (Suc (Suc Zero_nat)) = 2 then () else error "nat_int changed";

fun natopt_str NONE = "NONE"
  | natopt_str (SOME n) = "(SOME " ^ nat_str n ^ ")"

(* see ~~ src/HOL/Num.thy *)
fun dest_num One = 1
  | dest_num (Bit0 n') = 2 * dest_num n'
  | dest_num (Bit1 n') = 2 * dest_num n' + 1;

if dest_num (Bit0 (Bit1 One)) = 6 then () else error "dest_num changed";

fun int_str (Pos n) = n |> dest_num |> string_of_int |> curry op ^ "" 
  | int_str Zero_int = "0"
  | int_str (Neg n) = n |> dest_num |> string_of_int |> curry op ^ "~";

if int_str (Pos (Bit0 (Bit1 One))) = "6" then () else error "int_str Pos changed";
if int_str (Neg (Bit0 (Bit1 One))) = "~6" then () else error "int_str Neg changed";

fun poly_str (Coeff c) = "Coeff " ^ int_str c
  | poly_str (Powers (Dense (Abs_nat_mapping_dense ps))) =
      "Powers [" ^ (commas (map poly_str ps)) ^ "]"
  | poly_str _ = error "poly_str only implemented for Rec Dense";

if poly_str (Powers (Dense (Abs_nat_mapping_dense [
     Powers (Dense (Abs_nat_mapping_dense [
       Coeff Zero_int, Coeff (Pos (Bit0 (Bit0 (Bit0 One))))])), 
     Coeff (Pos (Bit0 (Bit1 (Bit0 One))))]))) = "Powers [Powers [Coeff 0, Coeff 8], Coeff 10]"
then () else error "poly_str changed";

fun polys_str ps = "[" ^ (commas (map poly_str ps)) ^ "]"

fun nat_m_str (Dense (Abs_nat_mapping_dense ps)) = 
      "Dense (Abs_nat_map.. " ^ (commas (map poly_str ps)) ^ ")"
  | nat_m_str _  = error "nat_m_str only implemented for Rec Dense";

if nat_m_str (Dense (Abs_nat_mapping_dense [
     Powers (Dense (Abs_nat_mapping_dense [
       Coeff Zero_int, Coeff (Pos (Bit0 (Bit0 One)))])), 
     Coeff (Pos (Bit1 (Bit0 One)))])) 
  = "Dense (Abs_nat_map.. Powers [Coeff 0, Coeff 4], Coeff 5)"
then () else error "nat_m_str changed";

fun indent 0 mark = mark
  | indent n mark = "   " ^ indent (n - 1) mark;

if indent 0 "###" = "###" then () else error "indent 0 ### changed";
if indent 1 "###" = "   ###" then () else error "indent 1 ### changed";
if indent 0 "#####" = "#####" then () else error "indent 0 ##### changed";
(*\---------- prepare investigation of foldr ---------------------------------------------------/*)

fun id x = (fn xa => xa) x;

fun foldr f [] = id
  | foldr f (x :: xs) = f x o foldr f xs;

fun map fi [] = []
  | map fi (x21a :: x22) = fi x21a :: map fi x22;

fun plus_nat (Suc m) n = plus_nat m (Suc n)
  | plus_nat Zero_nat n = n;

val one_nat : nat = Suc Zero_nat;

fun nat_of_num (Bit1 n) = let
                            val m = nat_of_num n;
                          in
                            Suc (plus_nat m m)
                          end
  | nat_of_num (Bit0 n) = let
                            val m = nat_of_num n;
                          in
                            plus_nat m m
                          end
  | nat_of_num One = one_nat;

fun foldr_sparse A_ x xc =
  foldr (fn (a, b) => x a b) (rep_nat_mapping_sparse A_ xc);

*} ML {*
*} text {* (*original*)
fun foldr_dense_raw (A1_, A2_) f n [] b = b
  | foldr_dense_raw (A1_, A2_) f n (x :: xs) b =
    (if eq A2_ x (zero A1_) then id else f n x)
      (foldr_dense_raw (A1_, A2_) f (Suc n) xs b);
*} ML {*
fun foldr_dense_raw (*1*) (A1_, A2_) f n [] b =
((*writeln*) (". . . . . . . . -foldr_dense_raw (*1*)" ^ nat_str n ^ " [] " (*^ poly_str b ^ ")" restricts signat.*));
  b
)
  | foldr_dense_raw (A1_, A2_) f n (x :: xs) b =
  let 
    val _ = (*writeln*) (". . . . . . . . ./foldr_dense_raw (*2*)" ^ nat_str n ^ " [] " (*^ poly_str b ^ ")" restricts signat.*));
    val vvv = (if eq A2_ x (zero A1_) then id else f n x)
      (foldr_dense_raw (A1_, A2_) f (Suc n) xs b)
    val _ = (*writeln*) (". . . . . . . . .\\foldr_dense_raw (*2*)" ^ nat_str n ^ " [] " (*^ poly_str b ^ ")" restricts signat.*));
  in vvv end;
*} ML {*

fun foldr_dense (A1_, A2_) x xc =
  foldr_dense_raw (A1_, A2_) x Zero_nat (rep_nat_mapping_dense A1_ xc);

fun foldra (A1_, A2_) f (Sparse xs) z = foldr_sparse A1_ f xs z
  | foldra (A1_, A2_) f (Dense xs) z =
  let 
    val _ = writeln (". . . . . . . . ./foldra (" (*^ nat_m_str (Dense xs) ..type error in monom_rec*))
    val vvv = foldr_dense (A1_, A2_) f xs z
    val _ = writeln (". . . . . . . . .\\foldra (" (*^ nat_m_str (Dense xs) ..type error in monom_rec*))
  in vvv end;
*} ML {*
foldra;
nat_m_str;
Dense
*} ML {* (* original *)
fun foldr_step (A1_, A2_) f g p x =
  let
    val (c, n) = foldra (A1_, A2_) (fn n => fn v => fn (c, na) => (f n v (g n na c), SOME n)) 
      p (x, NONE);
  in g Zero_nat n c end;
*} ML {*
natopt_str
*} ML {*
fun foldr_step (A1_, A2_) f g p x =
  let
    val _ = writeln (". . . . . . . . /foldr_step (" ^ nat_m_str p ^ ") ("  ^ poly_str x ^ ")...")
    val (c, n) =
      foldra (A1_, A2_)
        (fn n => fn v => fn (c, na) => (f n v (g n na c), SOME n)) p (x, NONE);
    val _ = writeln (". . . . . . . . \\foldr_step (" ^ nat_m_str p ^ ") ("  ^ poly_str x ^ ") \<longrightarrow> " ^
      " (" ^ poly_str c ^ ", " ^ natopt_str n ^ ")")
  in
    g Zero_nat n c
  end;
*} ML {*
foldr_step;
*} ML {*
nat_m_str;
*} ML {*

fun minus_nat (Suc m) (Suc n) = minus_nat m n
  | minus_nat Zero_nat n = Zero_nat
  | minus_nat m Zero_nat = m;

fun apfst f (x, y) = (f x, y);

fun add_keys_sparse A_ xb xc =
  Abs_nat_mapping_sparse
    (map (apfst (plus_nat xb)) (rep_nat_mapping_sparse A_ xc));

fun add_keys_dense A_ xb xc =
  Abs_nat_mapping_dense
    (if null (rep_nat_mapping_dense A_ xc) then []
      else replicate xb (zero A_) @ rep_nat_mapping_dense A_ xc);

fun add_keys A_ n (Sparse xs) = Sparse (add_keys_sparse A_ n xs)
  | add_keys A_ n (Dense xs) = Dense (add_keys_dense A_ n xs);

fun mapp_sparse_raw A_ B_ C_ g xs = map (fn (k, v) => (k, g k v)) xs;

fun mapp_sparse B_ A_ xb xc =
  Abs_nat_mapping_sparse
    (mapp_sparse_raw linorder_nat B_ A_ xb (rep_nat_mapping_sparse B_ xc));

fun mapp_dense_raw (A1_, A2_) (B1_, B2_) g n [] = []
  | mapp_dense_raw (A1_, A2_) (B1_, B2_) g n (x :: xs) =
    let
      val zs = mapp_dense_raw (A1_, A2_) (B1_, B2_) g (Suc n) xs;
      val z = apply0 (A1_, A2_) B1_ (g n) x;
    in
      (if null zs andalso eq B2_ z (zero B1_) then [] else z :: zs)
    end;

fun mapp_dense (B1_, B2_) (A1_, A2_) xb xc =
  Abs_nat_mapping_dense
    (mapp_dense_raw (B1_, B2_) (A1_, A2_) xb Zero_nat
      (rep_nat_mapping_dense B1_ xc));

fun mapp (A1_, A2_) (B1_, B2_) f (Sparse xs) = Sparse (mapp_sparse A1_ B1_ f xs)
  | mapp (A1_, A2_) (B1_, B2_) f (Dense xs) =
    Dense (mapp_dense (A1_, A2_) (B1_, B2_) f xs);

fun inc_power_rec (*1*) (A1_, A2_) impl Zero_nat (Coeff a) =
let
  val vvv = (if eq A2_ a (zero A1_) then Coeff (zero A1_)
    else Powers
           (single (zero_poly_rec A1_, equal_poly_rec (A1_, A2_)) impl one_nat
             (Coeff a)))
  val _ = writeln ("   ### inc_power_rec (*1*) " ^ nat_str Zero_nat ^ " (" ^ poly_str (Coeff a) ^
    ") \<longrightarrow> (" ^ poly_str vvv ^ ")");
in vvv end
  | inc_power_rec (*2*) (A1_, A2_) uu Zero_nat (Powers ps) =
let
  val vvv = Powers (add_keys (zero_poly_rec A1_) one_nat ps)
  val _ = writeln ("   ### inc_power_rec (*2*) " ^ nat_str Zero_nat ^ " (" ^ poly_str (Powers ps) ^
    ") \<longrightarrow> (" ^ poly_str vvv ^ ")");
in vvv end
  | inc_power_rec (*3*) (A1_, A2_) impl (Suc v) (Coeff a) =
let
  val vvv = (if eq A2_ a (zero A1_) then Coeff (zero A1_)
      else Powers
             (single (zero_poly_rec A1_, equal_poly_rec (A1_, A2_)) impl one_nat
               (inc_power_rec (A1_, A2_) impl (minus_nat (Suc v) one_nat)
                 (Coeff a))))
  val _ = writeln ("   ### inc_power_rec (*3*) " ^ nat_str (Suc v) ^ " (" ^ poly_str (Coeff a) ^
    ") \<longrightarrow> (" ^ poly_str vvv ^ ")");
in vvv end
  | inc_power_rec (*4*) (A1_, A2_) impl (Suc v) (Powers ps) =
let
  val vvv =  Powers
      (mapp (zero_poly_rec A1_, equal_poly_rec (A1_, A2_))
        (zero_poly_rec A1_, equal_poly_rec (A1_, A2_))
        (fn _ => inc_power_rec (A1_, A2_) impl (minus_nat (Suc v) one_nat)) ps)
  val _ = writeln ("   ### inc_power_rec (*4*) " ^ nat_str (Suc v) ^ " (" ^ poly_str (Powers ps) ^
    ") \<longrightarrow> (" ^ poly_str vvv ^ ")");
in vvv end;

fun smult_rec (A1_, A2_, A3_) s (Coeff c) = Coeff (timesa A1_ s c)
  | smult_rec (A1_, A2_, A3_) s (Powers ps) =
    (if eq A3_ s (zero A2_) then Coeff (zero A2_)
      else Powers
             (mapp (zero_poly_rec A2_, equal_poly_rec (A2_, A3_))
               (zero_poly_rec A2_, equal_poly_rec (A2_, A3_))
               (fn _ => smult_rec (A1_, A2_, A3_) s) ps));

fun funpow Zero_nat f = (fn x => x)
  | funpow (Suc n) f = f o funpow n f;

(* ------------------------------------------------------ original:*)
fun times (A1_, A2_, A3_) uu (Coeff a) (Coeff b) = Coeff (timesa A2_ a b)
  | times (A1_, A2_, A3_) uv (Coeff a) (Powers qs) =
    Powers
      (mapp (zero_poly_rec (zero_monoid_add A1_),
              equal_poly_rec (zero_monoid_add A1_, A3_))
        (zero_poly_rec (zero_monoid_add A1_),
          equal_poly_rec (zero_monoid_add A1_, A3_))
        (fn _ => smult_rec (A2_, zero_monoid_add A1_, A3_) a) qs)
  | times (A1_, A2_, A3_) uw (Powers ps) (Coeff b) =
    Powers
      (mapp (zero_poly_rec (zero_monoid_add A1_),
              equal_poly_rec (zero_monoid_add A1_, A3_))
        (zero_poly_rec (zero_monoid_add A1_),
          equal_poly_rec (zero_monoid_add A1_, A3_))
        (fn _ => smult_rec (A2_, zero_monoid_add A1_, A3_) b) ps)
  | times (A1_, A2_, A3_) lev (Powers ps) (Powers v) =
    foldr_step
      (zero_poly_rec (zero_monoid_add A1_),
        equal_poly_rec (zero_monoid_add A1_, A3_))
      (fn _ => fn a => fn p =>
        plus_poly_reca (A1_, A3_)
          (times (A1_, A2_, A3_) (plus_nat lev one_nat) a (Powers v))
          (inc_power_rec (zero_monoid_add A1_, A3_)
            (implT (zero_poly_rec (zero_monoid_add A1_)) ps) lev p))
      (fn n => fn na => fn p =>
        let
          val naa = (case na of NONE => Zero_nat | SOME nb => nb);
        in
          funpow (minus_nat naa n)
            (inc_power_rec (zero_monoid_add A1_, A3_)
              (implT (zero_poly_rec (zero_monoid_add A1_)) ps) lev)
            p
        end)
      ps (Coeff (zero (zero_monoid_add A1_)));

fun times (*1*) (A1_, A2_, A3_) uu (Coeff a) (Coeff b) = 
(writeln (indent (nat_int uu) "###" ^ " times (*1*): lev = " ^ nat_str uu ^ 
"  (Coeff " ^ int_str a ^ ") * (Coeff " ^ int_str b ^ 
") \<longrightarrow> (" ^ poly_str (Coeff (timesa A2_ a b)) ^ ")");
    Coeff (timesa A2_ a b)
)
  | times (*2*) (A1_, A2_, A3_) uv (Coeff a) (Powers qs) =
let val xxx = Powers
      (mapp (zero_poly_rec (zero_monoid_add A1_),
              equal_poly_rec (zero_monoid_add A1_, A3_))
        (zero_poly_rec (zero_monoid_add A1_),
          equal_poly_rec (zero_monoid_add A1_, A3_))
        (fn _ => smult_rec (A2_, zero_monoid_add A1_, A3_) a) qs)
in
(writeln (indent (nat_int uv) "###" ^ " times (*2*): lev = " ^ nat_str uv ^ 
"  (Coeff " ^ int_str a ^ ") * (" ^ poly_str (Powers qs) ^ ") \<longrightarrow> (" ^ poly_str xxx ^ ")");
    xxx
)
end
  | times (*3*) (A1_, A2_, A3_) uw (Powers ps) (Coeff b) =
let val xxx = Powers
      (mapp (zero_poly_rec (zero_monoid_add A1_),
              equal_poly_rec (zero_monoid_add A1_, A3_))
        (zero_poly_rec (zero_monoid_add A1_),
          equal_poly_rec (zero_monoid_add A1_, A3_))
        (fn _ => smult_rec (A2_, zero_monoid_add A1_, A3_) b) ps)
in
(writeln (indent (nat_int uw) "###" ^ " times (*3*): lev = " ^ nat_str uw ^ 
"  (" ^ poly_str (Powers ps) ^ ") * (Coeff " ^ int_str b ^ ") \<longrightarrow> (" ^ poly_str xxx ^ ")");
    xxx
)
end
  | times (*4*) (A1_, A2_, A3_) lev (Powers ps) (Powers v) =
let 
  val _ = writeln (indent (nat_int lev) "/##" ^ " times (*4*): lev = " ^ nat_str lev ^ 
"  (" ^ poly_str (Powers ps) ^ ") * (Coeff " ^ poly_str (Powers v) ^ ")...");
  val xxx = foldr_step
      (zero_poly_rec (zero_monoid_add A1_),
        equal_poly_rec (zero_monoid_add A1_, A3_))
      (fn n => fn a => fn p =>
  let val _ = writeln (indent (nat_int lev) " /####" ^ " f\<lambda> " ^ nat_str n ^ 
      "  (" ^ poly_str a ^ ")  (" ^ poly_str p ^ "). ...")
      val prod = times (A1_, A2_, A3_) (Suc lev) a (Powers v)
      val inc = inc_power_rec (zero_monoid_add A1_, A3_)
              (implT (zero_poly_rec (zero_monoid_add A1_)) ps) lev p
      val sum = plus_poly_reca (A1_, A3_) prod inc
  in
    (writeln (indent (nat_int lev) " \\####" ^ " f\<lambda> " ^ nat_str n ^ 
      "  (" ^ poly_str a ^ ")  (" ^ poly_str p ^ "). (" ^ 
      poly_str prod ^ ") + (" ^ poly_str inc ^ ") \<longrightarrow> (" ^ poly_str sum ^ ")");
          sum)
  end)
      (fn n => fn na => fn p =>
        let 
          val naa = (case na of NONE => Zero_nat | SOME nb => nb);
          val vvv = funpow (minus_nat naa n)
            (inc_power_rec (zero_monoid_add A1_, A3_)
              (implT (zero_poly_rec (zero_monoid_add A1_)) ps) lev)
            p
        in
(writeln (indent (nat_int lev) " -#### g\<lambda> " ^ nat_str n ^ " " ^ natopt_str na ^ 
            " (" ^ poly_str p ^ ") (funpow " ^ nat_str naa ^ "-" ^ nat_str n ^ " inc_power_rec " ^
            poly_str p ^ ") \<longrightarrow> (" ^ poly_str vvv ^ ")" );
          vvv
)
        end)
      ps (Coeff (zero (zero_monoid_add A1_)))
in
(writeln (indent (nat_int lev) "\\##" ^ " times (*4*): lev = " ^ nat_str lev ^ 
"  (" ^ poly_str (Powers ps) ^ ") * (Coeff " ^ poly_str (Powers v) ^ ") \<longrightarrow> (" ^ poly_str xxx ^ ")");
    xxx
)
end
*} ML {*
fun raw_of_poly_distr A_ (Poly_distr_of_raw x) = x;

fun equal_monom_order Rlex_mo Rlex_mo = true
  | equal_monom_order Rlex_mo Lex_mo = false
  | equal_monom_order Lex_mo Rlex_mo = false
  | equal_monom_order Lex_mo Lex_mo = true;

fun insort_by compare x [] = [x]
  | insort_by compare x (y :: ys) =
    (case compare x y of General.LESS => x :: y :: ys | General.EQUAL => y :: ys
      | General.GREATER => y :: insort_by compare x ys);

fun sort_by compare xs = foldr (insort_by compare) xs [];

fun compare_nat_mapping (A1_, A2_, A3_) =
  comparator_of_le (ord_nat_mapping (A2_, A3_, linorder_linorder_compare A1_));

fun monom_compare Rlex_mo =
  uminus_funa (uminus_fun uminus_comparison)
    (compare_nat_mapping (linorder_compare_nat, zero_nat, equal_nat))
  | monom_compare Lex_mo =
    compare_nat_mapping (linorder_compare_nat, zero_nat, equal_nat);

fun compare_vimage f compare x y = compare (f x) (f y);

fun fst (x1, x2) = x1;

fun plus_distr_raw (A1_, A2_, A3_) (p1, cmp1) (p2, cmp2) =
  (if equal_monom_order cmp1 cmp2
    then (oa_zip_with (monom_compare cmp1) (fn _ => SOME) (fn _ => SOME)
            (fn _ => fn x => fn y =>
              let
                val z = plus A1_ x y;
              in
                (if eq A3_ z (zero A2_) then NONE else SOME z)
              end)
            p1 p2,
           cmp1)
    else let
           val cmp = monom_compare cmp1;
           val p2a = sort_by (compare_vimage fst cmp) p2;
         in
           (oa_zip_with cmp (fn _ => SOME) (fn _ => SOME)
              (fn _ => fn x => fn y =>
                let
                  val z = plus A1_ x y;
                in
                  (if eq A3_ z (zero A2_) then NONE else SOME z)
                end)
              p1 p2a,
             cmp1)
         end);

fun plus_poly_distr (A1_, A2_) p q =
  Poly_distr_of_raw
    (plus_distr_raw
      ((plus_semigroup_add o semigroup_add_monoid_add) A1_, zero_monoid_add A1_,
        A2_)
      (raw_of_poly_distr (zero_monoid_add A1_) p)
      (raw_of_poly_distr (zero_monoid_add A1_) q));

*} ML {*
fun plus_mpoly (A1_, A2_, A3_) (Rec p) (Rec q) =
  Rec (plus_poly_reca
        ((monoid_add_group_add o group_add_ab_group_add o ab_group_add_ring)
           A3_,
          A2_)
        p q)
  | plus_mpoly (A1_, A2_, A3_) (Distr p) (Distr q) =
    Distr (plus_poly_distr
            ((monoid_add_group_add o group_add_ab_group_add o ab_group_add_ring)
               A3_,
              A2_)
            p q);

fun monom_distr_impl (A1_, A2_) mo m c =
  Poly_distr_of_raw (if eq A2_ c (zero A1_) then ([], mo) else ([(m, c)], mo));

fun monom_distr (A1_, A2_) mo m c = Distr (monom_distr_impl (A1_, A2_) mo m c);

fun monom_distr_ignore (A1_, A2_) = Abs_ignore_arg (monom_distr (A1_, A2_));

fun apply_ignore (Abs_ignore_arg x) = x;

fun switch_monom_order f RLEX = apply_ignore f Rlex_mo
  | switch_monom_order f LEX = apply_ignore f Lex_mo;

fun monom_distra (A1_, A2_) =
  switch_monom_order (monom_distr_ignore (A1_, A2_));

fun shift_rec (A1_, A2_) (Coeff x) n = Coeff x
  | shift_rec (A1_, A2_) (Powers ps) Zero_nat = Powers ps
  | shift_rec (A1_, A2_) (Powers ps) (Suc n) =
    Powers
      (single (zero_poly_rec A1_, equal_poly_rec (A1_, A2_))
        (implT (zero_poly_rec A1_) ps) Zero_nat
        (shift_rec (A1_, A2_) (Powers ps) n));

fun monom_rec (A1_, A2_) impl m c =
  (if eq A2_ c (zero A1_) then Coeff (zero A1_)
    else let
           val (a, b) =
             foldra (zero_nat, equal_nat)
               (fn v => fn n => fn (p, va) =>
                 (Powers
                    (single (zero_poly_rec A1_, equal_poly_rec (A1_, A2_))
                      (impl n) n (shift_rec (A1_, A2_) p (minus_nat va v))),
                   v))
               m (Coeff c, Zero_nat);
         in
           shift_rec (A1_, A2_) a b
         end);

fun monom (A1_, A2_, A3_) (DISTR mo) m c =
  monom_distra
    ((zero_mult_zero o mult_zero_semiring_0 o semiring_0_semiring_0_cancel o
       semiring_0_cancel_ring)
       A3_,
      A2_)
    mo m c
  | monom (A1_, A2_, A3_) (REC impl) m c =
    Rec (monom_rec
          ((zero_mult_zero o mult_zero_semiring_0 o
             semiring_0_semiring_0_cancel o semiring_0_cancel_ring)
             A3_,
            A2_)
          impl m c);

val p45 : int mpoly =
  plus_mpoly (one_int, equal_int, ring_int)
    (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
      (single (zero_nat, equal_nat) DENSE Zero_nat Zero_nat)
      (Pos (Bit0 (Bit0 One))))
    (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
      (single (zero_nat, equal_nat) DENSE Zero_nat one_nat)
      (Pos (Bit1 (Bit0 One))));

val p2x3y : int mpoly =
  plus_mpoly (one_int, equal_int, ring_int)
    (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
      (single (zero_nat, equal_nat) DENSE one_nat one_nat) (Pos (Bit0 One)))
    (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
      (single (zero_nat, equal_nat) DENSE Zero_nat one_nat) (Pos (Bit1 One)));

val p4x5y : int mpoly =
  plus_mpoly (one_int, equal_int, ring_int)
    (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
      (single (zero_nat, equal_nat) DENSE one_nat one_nat)
      (Pos (Bit0 (Bit0 One))))
    (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
      (single (zero_nat, equal_nat) DENSE Zero_nat one_nat)
      (Pos (Bit1 (Bit0 One))));

val p0002003 : int mpoly =
  plus_mpoly (one_int, equal_int, ring_int)
    (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
      (single (zero_nat, equal_nat) DENSE Zero_nat (nat_of_num (Bit1 One)))
      (Pos (Bit0 One)))
    (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
      (single (zero_nat, equal_nat) DENSE Zero_nat
        (nat_of_num (Bit0 (Bit1 One))))
      (Pos (Bit1 One)));

val p1002003 : int mpoly =
  plus_mpoly (one_int, equal_int, ring_int)
    (plus_mpoly (one_int, equal_int, ring_int)
      (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
        (single (zero_nat, equal_nat) DENSE Zero_nat Zero_nat) (Pos One))
      (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
        (single (zero_nat, equal_nat) DENSE Zero_nat (nat_of_num (Bit1 One)))
        (Pos (Bit0 One))))
    (monom (one_int, equal_int, ring_int) (REC (fn _ => DENSE))
      (single (zero_nat, equal_nat) DENSE Zero_nat
        (nat_of_num (Bit0 (Bit1 One))))
      (Pos (Bit1 One)));

fun times_poly_rec (A1_, A2_) =
  times ((monoid_add_comm_monoid_add o comm_monoid_add_semiring_0) A2_,
          (times_mult_zero o mult_zero_semiring_0) A2_, A1_)
    Zero_nat;

fun times_mpoly (A1_, A2_, A3_) (Rec p) (Rec q) =
  Rec (times_poly_rec
        (A2_, (semiring_0_semiring_0_cancel o semiring_0_cancel_ring) A3_) p q);

fun try_times p q = times_mpoly (one_int, equal_int, ring_int) p q;

(*end; struct Try_Times*)
*} ML {*
*}
subsubsection {* test inc_power_rec *}
ML {* (* with foldra instead foldr_step for simplicity reasons *)
"~~~~~~~~~ fun try_times, args:"; val (p, q) = (p2x3y, p4x5y);
"~~~~~~~~~ fun times_mpoly, args:"; val ((A1_, A2_, A3_), (Rec p), (Rec q)) = 
  ((one_int, equal_int, ring_int), p, q);
"~~~~~~~~~ fun times_poly_rec, args:"; val (A1_', A2_') = 
  ((A2_, (semiring_0_semiring_0_cancel o semiring_0_cancel_ring) A3_)(*, p, q*));
"~~~~~~~~~ fun times (*4*), args:"; val ((A1_'', A2_'', A3_''), lev, (Powers ps), (Powers v)) = 
  (((monoid_add_comm_monoid_add o comm_monoid_add_semiring_0) A2_',
    (times_mult_zero o mult_zero_semiring_0) A2_', A1_'), Zero_nat, p, q);
"~~~~~ fun foldra, args:"; val ((A1_, A2_)(*''' stopped due OK below*), f, (Dense xs), z) = 
  ((zero_poly_rec (zero_monoid_add A1_''), equal_poly_rec (zero_monoid_add A1_'', A3_'')),
  (fn _ => fn a => fn p =>                 
    plus_poly_reca (A1_'', A3_'') (times (A1_'', A2_'', A3_'') (Suc lev) a (Powers v))
      (inc_power_rec (zero_monoid_add A1_'', A3_'')
        (implT (zero_poly_rec (zero_monoid_add A1_'')) ps) lev p)) : nat -> int poly_rec -> int poly_rec -> int poly_rec ,
  ps,                         (Coeff (zero (zero_monoid_add A1_''))));
*} ML {*
val lev = Zero_nat
val inc = inc_power_rec (zero_monoid_add A1_'', A3_'') 
  (implT (zero_poly_rec (zero_monoid_add A1_'')) ps);
val xxx = inc lev p;
poly_str xxx = "Powers [Coeff 0, Powers [Coeff 0, Coeff 2], Coeff 3]";
val lev = Suc Zero_nat;
val xxx = inc lev p;
poly_str xxx;
poly_str xxx = "Powers [Powers [Coeff 0, Coeff 0, Coeff 2], Powers [Coeff 0, Coeff 3]]"
*} ML {*
val lev = Zero_nat;
val xxx = funpow Zero_nat (inc lev) p;
poly_str xxx = "Powers [Powers [Coeff 0, Coeff 2], Coeff 3]";

val xxx = funpow (Suc Zero_nat) (inc lev) p;
poly_str xxx = "Powers [Coeff 0, Powers [Coeff 0, Coeff 2], Coeff 3]";

val xxx = funpow (Suc (Suc Zero_nat)) (inc lev) p;
poly_str xxx = "Powers [Coeff 0, Coeff 0, Powers [Coeff 0, Coeff 2], Coeff 3]";
*}

subsubsection {* Mult. foldr_step writeln /###\ SIMPLE *}
ML {*
if try_times p0002003 p45 = Rec (Powers (Dense (Abs_nat_mapping_dense [
  Coeff Zero_int, Coeff Zero_int, Coeff Zero_int, (* 0, 0, 0 OK *)
  Coeff (Pos (Bit0 (Bit0 (Bit0 One)))),           (* 8       OK *)
  Coeff (Pos (Bit0 (Bit1 (Bit0 One)))),           (* 10      OK *)
  Coeff Zero_int,                                 (* 0       OK *)
  Coeff Zero_int,                                 (* ////////// too much !!!*)
  Coeff (Pos (Bit0 (Bit0 (Bit1 One)))),           (* 12      OK *)
  Coeff (Pos (Bit1 (Bit1 (Bit1 One))))] ) ) )     (* 15      OK *)
then () else error "(wrong) try_times p002003 p45 changed"
*} text {*
OK  /## times (*4*): lev = #0  (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 2, Coeff 0, Coeff 0, Coeff 3]) * (Coeff Powers [Coeff 4, Coeff 5])... 
    . . . . . . . . /foldr_step (Dense (Abs_nat_map.. Coeff 0, Coeff 0, Coeff 0, Coeff 2, Coeff 0, Coeff 0, Coeff 3)) (Coeff 0)... 
    . . . . . . . . ./foldra ( 
     -#### g\<lambda> #6 NONE (Coeff 0) (funpow #0-#6 inc_power_rec Coeff 0) \<longrightarrow> (Coeff 0) 
OK   /#### f\<lambda> #6  (Coeff 3)  (Coeff 0). ... 
OK     ### times (*2*): lev = #1  (Coeff 3) * (Powers [Coeff 4, Coeff 5]) \<longrightarrow> (Powers [Coeff 12, Coeff 15]) 
       ### inc_power_rec (*1*) #0 (Coeff 0) \<longrightarrow> (Coeff 0)                                  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!this is too much: just add 2nd argument in f\<lambda>???
OK   \#### f\<lambda> #6  (Coeff 3)  (Coeff 0). (Powers [Coeff 12, Coeff 15]) + (Coeff 0) \<longrightarrow> (Powers [Coeff 12, Coeff 15]) 
-----
       ### inc_power_rec (*2*) #0 (Powers [Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 12, Coeff 15]) 
       ### inc_power_rec (*2*) #0 (Powers [Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
       ### inc_power_rec (*2*) #0 (Powers [Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
     -#### g\<lambda> #3 (SOME #6) (Powers [Coeff 12, Coeff 15]) (funpow #6-#3 inc_power_rec Powers [Coeff 12, Coeff 15]) 
OK      \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
OK   /#### f\<lambda> #3  (Coeff 2)  (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 12, Coeff 15]). ...                           
OK     ### times (*2*): lev = #1  (Coeff 2) * (Powers [Coeff 4, Coeff 5]) \<longrightarrow> (Powers [Coeff 8, Coeff 10]) 
       ### inc_power_rec (*2*) #0 (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!this is too much: just add 2nd argument in f\<lambda>???
        \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 0, Coeff 12, Coeff 15])             
OK   \#### f\<lambda> #3  (Coeff 2)  (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 12, Coeff 15]).     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!OK
@@//    (Powers [Coeff 8, Coeff 10]) + (Powers [//@@Coeff 0,@@// Coeff 0, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> 
@@//      (Powers [Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15])
-----
    . . . . . . . . .\foldra ( 
    . . . . . . . . \foldr_step (Dense (Abs_nat_map.. Coeff 0, Coeff 0, Coeff 0, Coeff 2, Coeff 0, Coeff 0, Coeff 3)) (Coeff 0) \<longrightarrow>  (Powers [Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15], (SOME #3)) 
       ### inc_power_rec (*2*) #0 (Powers [Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
       ### inc_power_rec (*2*) #0 (Powers [Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
       ### inc_power_rec (*2*) #0 (Powers [Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
     -#### g\<lambda> #0 (SOME #3) (Powers [Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) (funpow #3-#0 inc_power_rec Powers [Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
    \## times (*4*): lev = #0  (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 2, Coeff 0, Coeff 0, Coeff 3]) * (Coeff Powers [Coeff 4, Coeff 5]) \<longrightarrow> 
      (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
*} ML {*
*} ML {*
try_times p1002003 p45 = Rec (Powers (Dense (Abs_nat_mapping_dense [
  Coeff (Pos (Bit0 (Bit0 One))), 
  Coeff (Pos (Bit1 (Bit0 One))), 
  Coeff Zero_int, 
  Coeff Zero_int,                                 (* ////////// too much !!!*)
  Coeff (Pos (Bit0 (Bit0 (Bit0 One)))), 
  Coeff (Pos (Bit0 (Bit1 (Bit0 One)))),
  Coeff Zero_int, 
  Coeff Zero_int,                                 (* ////////// too much !!!*)
  Coeff (Pos (Bit0 (Bit0 (Bit1 One)))), 
  Coeff (Pos (Bit1 (Bit1 (Bit1 One))))] ) ) )
*} text {*
/## times (*4*): lev = #0  (Powers [Coeff 1, Coeff 0, Coeff 0, Coeff 2, Coeff 0, Coeff 0, Coeff 3]) * (Coeff Powers [Coeff 4, Coeff 5])... 
. . . . . . . . /foldr_step 
. . . . . . . . -foldr_dense_raw (*1*)#7 []  
 -#### g\<lambda> #6 NONE (Coeff 0) (funpow #0-#6 inc_power_rec Coeff 0) \<longrightarrow> (Coeff 0) 
 /#### f\<lambda> (#6)  (Coeff 3)  (Coeff 0). ... 
   ### times (*2*): lev = #1  (Coeff 3) * (Powers [Coeff 4, Coeff 5]) \<longrightarrow> (Powers [Coeff 12, Coeff 15]) 
   ### inc_power_rec (*1*) #0 (Coeff 0) \<longrightarrow> (Coeff 0) 
 \#### f\<lambda> (#6)  (Coeff 3)  (Coeff 0). (Powers [Coeff 12, Coeff 15]) + (Coeff 0) \<longrightarrow> (Powers [Coeff 12, Coeff 15]) 
   ### inc_power_rec (*2*) #0 (Powers [Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 12, Coeff 15]) 
   ### inc_power_rec (*2*) #0 (Powers [Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
   ### inc_power_rec (*2*) #0 (Powers [Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
 -#### g\<lambda> #3 (SOME #6) (Powers [Coeff 12, Coeff 15]) (funpow #6-#3 inc_power_rec Powers [Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
 /#### f\<lambda> (#3)  (Coeff 2)  (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 12, Coeff 15]). ... 
   ### times (*2*): lev = #1  (Coeff 2) * (Powers [Coeff 4, Coeff 5]) \<longrightarrow> (Powers [Coeff 8, Coeff 10]) 
   ### inc_power_rec (*2*) #0 (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
 \#### f\<lambda> (#3)  (Coeff 2)  (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 12, Coeff 15]). (Powers [Coeff 8, Coeff 10]) + (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
   ### inc_power_rec (*2*) #0 (Powers [Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
   ### inc_power_rec (*2*) #0 (Powers [Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
   ### inc_power_rec (*2*) #0 (Powers [Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
 -#### g\<lambda> #0 (SOME #3) (Powers [Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) (funpow #3-#0 inc_power_rec Powers [Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
 /#### f\<lambda> (#0)  (Coeff 1)  (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]). ... 
   ### times (*2*): lev = #1  (Coeff 1) * (Powers [Coeff 4, Coeff 5]) \<longrightarrow> (Powers [Coeff 4, Coeff 5]) 
   ### inc_power_rec (*2*) #0 (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
 \#### f\<lambda> (#0)  (Coeff 1)  (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]). (Powers [Coeff 4, Coeff 5]) + (Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 4, Coeff 5, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
. . . . . . . .\foldr_step 
 -#### g\<lambda> #0 (SOME #0) (Powers [Coeff 4, Coeff 5, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) (funpow #0-#0 inc_power_rec Powers [Coeff 4, Coeff 5, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) \<longrightarrow> (Powers [Coeff 4, Coeff 5, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
\## times (*4*): lev = #0  (Powers [Coeff 1, Coeff 0, Coeff 0, Coeff 2, Coeff 0, Coeff 0, Coeff 3]) * (Coeff Powers [Coeff 4, Coeff 5]) \<longrightarrow> (Powers [Coeff 4, Coeff 5, Coeff 0, Coeff 0, Coeff 8, Coeff 10, Coeff 0, Coeff 0, Coeff 12, Coeff 15]) 
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*} 
subsubsection {* Mult. foldr_step writeln /###\ (2.x + 3.y).(4.x + 5.y) *}
ML {*
*} ML {*
try_times p2x3y p4x5y
*} text {*
/## times (*4*): lev = #0  (Powers [Powers [Coeff 0, Coeff 2], Coeff 3]) * (Coeff Powers [Powers [Coeff 0, Coeff 4], Coeff 5])... 
. . . . . . . . /foldr_step (Dense (Abs_nat_map.. Powers [Coeff 0, Coeff 2], Coeff 3)) (Coeff 0)... 
. . . . . . . . -foldr_dense_raw (*1*)#2 []  
 -#### g\<lambda> #1 NONE (Coeff 0) (funpow #0-#1 inc_power_rec Coeff 0) \<longrightarrow> (Coeff 0) 
 /#### f\<lambda> (#1)  (Coeff 3)  (Coeff 0). ... 
   ### times (*2*): lev = #1  (Coeff 3) * (Powers [Powers [Coeff 0, Coeff 4], Coeff 5]) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 12], Coeff 15]) 
   ### inc_power_rec (*1*) #0 (Coeff 0) \<longrightarrow> (Coeff 0) 
 \#### f\<lambda> (#1)  (Coeff 3)  (Coeff 0). (Powers [Powers [Coeff 0, Coeff 12], Coeff 15]) + (Coeff 0) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 12], Coeff 15]) 
   ### inc_power_rec (*2*) #0 (Powers [Powers [Coeff 0, Coeff 12], Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Powers [Coeff 0, Coeff 12], Coeff 15]) 
 -#### g\<lambda> #0 (SOME #1) (Powers [Powers [Coeff 0, Coeff 12], Coeff 15]) (funpow #1-#0 inc_power_rec Powers [Powers [Coeff 0, Coeff 12], Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Powers [Coeff 0, Coeff 12], Coeff 15]) 
 /#### f\<lambda> (#0)  (Powers [Coeff 0, Coeff 2])  (Powers [Coeff 0, Powers [Coeff 0, Coeff 12], Coeff 15]). ... 
   /## times (*4*): lev = #1  (Powers [Coeff 0, Coeff 2]) * (Coeff Powers [Powers [Coeff 0, Coeff 4], Coeff 5])... 
. . . . . . . . /foldr_step (Dense (Abs_nat_map.. Coeff 0, Coeff 2)) (Coeff 0)... 
. . . . . . . . -foldr_dense_raw (*1*)#2 []  
    -#### g\<lambda> #1 NONE (Coeff 0) (funpow #0-#1 inc_power_rec Coeff 0) \<longrightarrow> (Coeff 0) 
    /#### f\<lambda> (#1)  (Coeff 2)  (Coeff 0). ... 
      ### times (*2*): lev = #2  (Coeff 2) * (Powers [Powers [Coeff 0, Coeff 4], Coeff 5]) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 8], Coeff 10]) 
   ### inc_power_rec (*3*) #1 (Coeff 0) \<longrightarrow> (Coeff 0) 
    \#### f\<lambda> (#1)  (Coeff 2)  (Coeff 0). (Powers [Powers [Coeff 0, Coeff 8], Coeff 10]) + (Coeff 0) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 8], Coeff 10]) 
. . . . . . . . \foldr_step (Dense (Abs_nat_map.. Coeff 0, Coeff 2)) (Coeff 0) \<longrightarrow>  (Powers [Powers [Coeff 0, Coeff 8], Coeff 10], (SOME #1)) 
   ### inc_power_rec (*1*) #0 (Coeff 10) \<longrightarrow> (Powers [Coeff 0, Coeff 10]) 
   ### inc_power_rec (*2*) #0 (Powers [Coeff 0, Coeff 8]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Coeff 8]) 
   ### inc_power_rec (*4*) #1 (Powers [Powers [Coeff 0, Coeff 8], Coeff 10]) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 10]]) 
    -#### g\<lambda> #0 (SOME #1) (Powers [Powers [Coeff 0, Coeff 8], Coeff 10]) (funpow #1-#0 inc_power_rec Powers [Powers [Coeff 0, Coeff 8], Coeff 10]) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 10]]) 
   \## times (*4*): lev = #1  (Powers [Coeff 0, Coeff 2]) * (Coeff Powers [Powers [Coeff 0, Coeff 4], Coeff 5]) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 10]]) 
   ### inc_power_rec (*2*) #0 (Powers [Coeff 0, Powers [Coeff 0, Coeff 12], Coeff 15]) \<longrightarrow> (Powers [Coeff 0, Coeff 0, Powers [Coeff 0, Coeff 12], Coeff 15]) 
 \#### f\<lambda> (#0)  (Powers [Coeff 0, Coeff 2])  (Powers [Coeff 0, Powers [Coeff 0, Coeff 12], Coeff 15]). (Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 10]]) + (Powers [Coeff 0, Coeff 0, Powers [Coeff 0, Coeff 12], Coeff 15]) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 10], Powers [Coeff 0, Coeff 12], Coeff 15]) 
. . . . . . . . \foldr_step (Dense (Abs_nat_map.. Powers [Coeff 0, Coeff 2], Coeff 3)) (Coeff 0) \<longrightarrow>  (Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 10], Powers [Coeff 0, Coeff 12], Coeff 15], (SOME #0)) 
 -#### g\<lambda> #0 (SOME #0) (Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 10], Powers [Coeff 0, Coeff 12], Coeff 15]) (funpow #0-#0 inc_power_rec Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 10], Powers [Coeff 0, Coeff 12], Coeff 15]) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 10], Powers [Coeff 0, Coeff 12], Coeff 15]) 
\## times (*4*): lev = #0  (Powers [Powers [Coeff 0, Coeff 2], Coeff 3]) * (Coeff Powers [Powers [Coeff 0, Coeff 4], Coeff 5]) \<longrightarrow> (Powers [Powers [Coeff 0, Coeff 0, Coeff 8], Powers [Coeff 0, Coeff 10], Powers [Coeff 0, Coeff 12], Coeff 15]) 
*} ML {*
*}

subsubsection {* Dictionary *}
ML {* (*SEE "~~m~~~~~~ fun times (*4*), args:" ABOVE*)
zero;                       (*: 'a zero -> 'a*)
zero_monoid_add;            (*: 'a monoid_add -> 'a zero*)
A1_;                        (*{zero_monoid_add = {zero = Zero_int}, ...}*)
(*zero_monoid_add A1_;                           {zero = Zero_int}*)
(*zero (zero_monoid_add A1_)                             Zero_int*)
*} ML {*
*}

subsubsection {**}

subsection {* Conversion, etc *}
subsubsection {* *}

subsubsection {* *}

subsubsection {**}


end
