theory Try_Nat_Mapping
imports "../poly-WORK/Nat_Mapping"
begin

subsection \<open>Type definition\<close>
(**)
subsection \<open>Additive structure\<close>
(**)
subsection \<open>Multiplicative structure\<close>
(**)
subsection \<open>Single-point mappings\<close>  
(*lift_definition single :: "nat \<Rightarrow> 'a \<Rightarrow> 'a::zero nat_mapping"
  is Poly_Mapping.single .*)
text {* -------------- for tests see single' -------------- *}

subsection \<open>Integral domains\<close>
(**)
subsection \<open>Mapping order\<close>
(**)
subsection \<open>Fundamental mapping notions\<close>
(**)
subsection \<open>Degree\<close>
(**)
subsection \<open>Inductive structure\<close>
(**)
subsection \<open>Misc material\<close>
(**)
subsection {* Dense implementation *}
(*typedef 'a :: zero nat_mapping_dense = "{xs :: 'a list. xs \<noteq> [] \<longrightarrow> last xs \<noteq> 0}"
by auto*)

(*definition apply0 :: "('a :: zero \<Rightarrow> 'b :: zero) \<Rightarrow> 'a \<Rightarrow> 'b" (infixl "0$" 100)
where "apply0 f x = (if x = 0 then 0 else f x)"
*)
definition plus10 :: "int \<Rightarrow> int" where "plus10 a = a + 10"
value "apply0 plus10 3" --{*"13"*}
value "plus10 0$ 3"     --{*"13"*}

value "apply0 plus10 0" --{*"0"*}
value "plus10 0$ 0"     --{*"c"*} 
value "(Groups.times (2::int) 0$ 3)" --{*"6"*}
value "(Groups.times (2::int) 0$ 0)" --{*"0"*}

(*fun strip_map :: "nat \<Rightarrow> 'a list \<Rightarrow> 'b list"     ...SEE context ! ! !
where
  "strip_map n [] = []"
| "strip_map n (x#xs) =
  (let ys = strip_map (Suc n) xs; y = f n 0$ x 
  in if ys = [] \<and> y = 0 then [] else y # ys)"*)
value "strip_map " --{* :: "(nat \<Rightarrow> 'a \<Rightarrow> 'b) \<Rightarrow> nat \<Rightarrow> 'a list \<Rightarrow> 'b list"*}

value "(\<lambda>a b. (int a) + b + 10)" --{* :: "nat \<Rightarrow> int \<Rightarrow> int"*}

value "strip_map (\<lambda>a b. (int a) + b + 10)" --{**}
value "strip_map (\<lambda>a b. (int a) + b + 10) 0 [0,2,0,3,0,4]" --{*"[0, 13, 0, 16, 0, 19]"*}
value "strip_map (\<lambda>a b. (int a) + b + 10) 1 [0,2,0,3,0,4]" --{*"[0, 14, 0, 17, 0, 20]"*}
value "strip_map (\<lambda>a b. (int a) + b + 10) 2 [0,2,0,3,0,4]" --{*"[0, 15, 0, 18, 0, 21]"*}

(*function zip_with_dense_raw :: "nat \<Rightarrow> 'a list \<Rightarrow> 'b list \<Rightarrow> 'c list"*)
value "zip_with_dense_raw" --{*:: "(nat \<Rightarrow> 'a \<Rightarrow> 'b \<Rightarrow> 'c) \<Rightarrow> nat \<Rightarrow> 'a list \<Rightarrow> 'b list \<Rightarrow> 'c list"*}

value "(\<lambda>a b c. (int a) + b + c + 10)" --{* :: "nat \<Rightarrow> int \<Rightarrow> int \<Rightarrow> int"*}

value "zip_with_dense_raw(\<lambda>a b c. (int a)+b+c+10) 0 [1,2,3,4,5] []"         --{*[11,13, 15,17, 19]*}
value "zip_with_dense_raw(\<lambda>a b c. (int a)+b+c+10) 0 [1,2,3,4,5] [1,2,3,4,5]"--{*[12,15, 18,21, 24]*}
value "zip_with_dense_raw(\<lambda>a b c. (int a)+b+c+10) 0 [1,0,3,0,5] [1,0,3,0,5]"--{*[12, 0, 18, 0, 24]*}
value "zip_with_dense_raw(\<lambda>a b c. (int a)+b+c+10) 1 [1,0,3,0,5] [1,0,3,0,5]"--{*[13, 0, 19, 0, 25]*}
value "zip_with_dense_raw(\<lambda>a b c. (int a)+b+c+10) 2 [1,0,3,0,5] [1,0,3,0,5]"--{*[14, 0, 20, 0, 26]*}

value "xxx" --{**}

(*---------------------\<longrightarrow> Namt_Mapping.thy ------------------------
context fixes f :: "nat \<Rightarrow> 'a :: zero \<Rightarrow> 'b :: zero" begin

function map_dense_raw :: "nat \<Rightarrow> 'a list \<Rightarrow> 'b list"
where
  "map_dense_raw n [] = []"
| "map_dense_raw n (x#xs) = 
  (let zs = map_dense_raw (Suc n) xs; z = apply0 (f n) x in if zs = [] \<and> z = 0 then [] else z # zs)"
by pat_completeness auto
termination by lexicographic_order

end
------------------------------------------------------------------*)
value "zip_with_dense_raw" --{* :: "(nat \<Rightarrow> 'a \<Rightarrow> 'b \<Rightarrow> 'c) \<Rightarrow> nat \<Rightarrow> 'a list \<Rightarrow> 'b list \<Rightarrow> 'c list"*}
value "map_dense_raw"      --{* :: "(nat \<Rightarrow> 'a      \<Rightarrow> 'b) \<Rightarrow> nat \<Rightarrow> 'a list            \<Rightarrow> 'b list"*}
value "xxx" --{**}
value "xxx" --{**}
value "xxx" --{**}



value "(\<lambda>a b. (int a) + b + 10)" --{* :: "nat \<Rightarrow> int \<Rightarrow> int"*}

value "map_dense_raw"  --{* :: "(nat \<Rightarrow> 'a \<Rightarrow> 'b) \<Rightarrow> nat \<Rightarrow> 'a list \<Rightarrow> 'b list"*}
value "map_dense_raw (\<lambda>a b. (int a)+b+10)" --{* :: "nat \<Rightarrow> 'a list \<Rightarrow> 'b list"*}
value "map_dense_raw (\<lambda>a b. (int a)+b+10) 0 [1,2,3,4,5]" --{*[11, 13, 15, 17, 19]*}
value "map_dense_raw (\<lambda>a b. (int a)+b+10) 0 [1,0,3,0,5]" --{*[11,  0, 15,  0, 19]*}
value "map_dense_raw (\<lambda>a b. (int a)+b+10) 1 [1,0,3,0,5]" --{*[12,  0, 16,  0, 20]*}
value "map_dense_raw (\<lambda>a b. (int a)+b+10) 2 [1,0,3,0,5]" --{*[13,  0, 17,  0, 21]*}

value "xxx" --{**}


subsection {* Sparse implementation *}
(**)
subsection {* Connection with @{typ "_ nat_mapping"} *}
(*lift_definition Dense :: "'a :: zero nat_mapping_dense \<Rightarrow> 'a nat_mapping"
is "\<lambda>xs. Poly_Mapping.make (nth xs) {0..<length xs}" ..*)
value "let xs = [1,2,3::nat]
  in nth xs" --{**}
value "xxx" --{**}

(*definition single' :: "impl \<Rightarrow> nat \<Rightarrow> 'a \<Rightarrow> 'a :: zero nat_mapping"
where [code del, simp]: "single' _ = single"*)
value "implT" --{* :: "(\<nat> \<Rightarrow>\<^sub>0 'a) \<Rightarrow> Nat_Mapping.impl"*}
value "Nat_Mapping.update" --{* :: "nat \<Rightarrow> 'a \<Rightarrow> (\<nat> \<Rightarrow>\<^sub>0 'a) \<Rightarrow> \<nat> \<Rightarrow>\<^sub>0 'a"*}
value "0 :: nat nat_mapping" --{* :: "\<nat> \<Rightarrow>\<^sub>0 nat"*}
value "xxx" --{**}
value "Nat_Mapping.update 0 (1 :: nat)" --{*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*}
value "Nat_Mapping.update 0 (1 :: int)" --{*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*}
value "xxx" --{**}
value "Nat_Mapping.update 0 (3 :: int) 0" --{* :: "\<nat> \<Rightarrow>\<^sub>0 int" ... not executable*}
value "Nat_Mapping.update 1 (3 :: int) 0" --{* :: "\<nat> \<Rightarrow>\<^sub>0 int"*}
value "Nat_Mapping.update 2 (3 :: int) 0" --{* :: "\<nat> \<Rightarrow>\<^sub>0 int"*}
value "Nat_Mapping.update 3 (3 :: int) 0" --{* :: "\<nat> \<Rightarrow>\<^sub>0 int"*}
value "Nat_Mapping.update 4 (3 :: int) 0" --{* :: "\<nat> \<Rightarrow>\<^sub>0 int"*}
value "Nat_Mapping.update 5 (3 :: int) 0" --{* :: "\<nat> \<Rightarrow>\<^sub>0 int"*}
value "xxx" --{**}
value "xxx" --{**}
value "xxx" --{**}
value "xxx" --{**}
value "xxx" --{**}
value "xxx" --{**}


(**)
(**)
(**)

end
